/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * COPSE Client Application
 * Classe:  ClientTest
\******************************************************************************/



import java.io.*;
import java.util.*;
import java.net.*;

import COPSE.*;


/*
class ConnectionManager
    extends Thread
{
//    UserSessionManager      pUserSessionManager
    int     mUserId;

    Socket  pSocket;
    ObjectInputStream pInput;
    ObjectOutputStream pOutput;

    boolean mExit;

    public ConnectionManager( String serverHost, String serverPort )
        throws UnknownHostException, IOException
    {
        super();

        System.out.println( "DEBUG: Connection Manager - Creating Socket ..." );
        pSocket = new Socket( serverHost, new Integer(serverPort).intValue() );

        System.out.println( "DEBUG: Connection Manager - Getting Streams ..." );
        try {
            InputStream in = pSocket.getInputStream();
            OutputStream out = pSocket.getOutputStream();

            System.out.println( "DEBUG: Connection Manager - Creating Object Streams ..." );
            pInput = new ObjectInputStream( in );
            pOutput = new ObjectOutputStream( out );
        }

        catch( Exception e )
        {
            System.out.println( "DEBUG: Connection Manager - Error..." );
        }

        System.out.println( "DEBUG: Connection Manager - Ok" );
        mUserId = 0;
        mExit = false;
    }

    public void run()
    {
        while( !mExit )
        {
            try{
                //if( pInput.available() != 0 )
                //{
                    System.out.println( "DEBUG: Receiving Event ...");
                    CEvent event = (CEvent) pInput.readObject();
                    //pUserSessionManager.ReceiveEvent(event);

                    // Temporary:
                    System.out.println( "DEBUG: Received event #" + event.GetType() );

                    switch( event.GetType() )
                    {
                        case CEvent.EvUserConnection_Open:
                            {
                                Integer i = (Integer)event.GetArgumentAt(0);
                                if( mUserId == 0 )
                                    mUserId = i.intValue();
                                else
                                    // TODO: Add User to Logged User List...
                                    System.out.println( "User "+i+" logged on!" );
                            }
                            break;

                        case CEvent.EvUserConnection_Close:
                            {
                                Integer i = (Integer)event.GetArgumentAt(0);
                                if( mUserId == i.intValue() )
                                {
                                    mExit = true;
                                }
                                else
                                    // TODO: Remove User to Logged User List...
                                    System.out.println( "User "+i+" logged out!" );
                            }

                    } // end switch

                //} // end if
            } catch(IOException ioe)
            {
                // TODO: Verify if the connection is still alive
            } catch(Exception e)
            {}
        } // while( !mExit )

        //pSocket.close();
        //Exit();
    }

    public synchronized void Send( CEvent event )
        throws IOException
    {
        pOutput.writeObject( event );
    }

    public void Exit()
    {
        try{
            pSocket.close();
        } catch( IOException ioe ) {};
        stop();
    }

}



*/



public class COPSEClientApp
{

    //ConnectionManager   pConMgr;
    COPSEClient     pClient;

    public static void main( String[] args )
    {
        COPSEClientApp app;
        app = new COPSEClientApp();

        //if( args.length == 4 )
            app.run( args );
        /*
        else
        {
            COPSEDlgLogin dlg = new COPSEDlgLogin( );
        }
        */
    }


    public COPSEClientApp()
    {
        pClient = null;
    }


    public void run( String[] args )
    {
        System.out.println( "COPSEClient - Test" );

        if( args.length < 4 )
        {
            System.out.println( "Parameters:\n   <host> <port_number> <user_login> <password>" );
            return;
        }

        try{
            System.out.println( "DEBUG: Creating Client" );
            pClient = new COPSEClient( args[0], new Integer(args[1]).intValue(), args[2], args[3] );
            pClient.start();
        }
        catch (Exception e)
        {
            e.printStackTrace( System.out );
            return;
        }

        if( pClient != null )
            _Execute();
    }

    private void _Execute( )
    {
/*
        CEvent event = new CEvent( CEvent.EvUserConnection_Open );
        event.AddArgument( login );
        event.AddArgument( login );

        try {
            System.out.println( "DEBUG: Sending OpenConnection Command..." );
            pConMgr.Send( event );
        } catch(IOException ioe )
        {
            System.out.println( "DEBUG: Error on sending 'OPENCONNECTION' command..." );
            pConMgr.Exit();
            System.exit(0);
        }
*/

        System.out.print(":");

        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

        String command;
        do {
            command = "";
            try {
                StringTokenizer st = new StringTokenizer(in.readLine());
                if( st.hasMoreTokens() )
                {
                    command = st.nextToken();

                    if( command.equals( "exit" ) )
                    {
                        System.out.println( "[DEBUG] COPSEClientApp - Exiting COPSEClient...");
                        if( pClient.isAlive() )
                        {
                            pClient.Exit();
                            System.out.println( "[DEBUG] Waiting for COPSEClient Thread finishing... ");
                            try{
                                pClient.join();
                            }catch(Exception e){};
                        }
                    }
                    else
                        System.out.print(":");
                }
            } catch (IOException ioe )
            {
                System.out.println( "DEBUG: Error os String Tokenizer ...");
            }

        } while( !command.equals("exit") );

        try {
            pClient.join(100);
        } catch (Exception e ) {};
    }
}
