/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Client Application
 * Classe: COPSEClientEventDispatcher
\******************************************************************************/


import java.io.*;
import java.net.*;
import java.util.*;


import COPSE.*;
import COPSE.CLIENT.*;


public class COPSEClientEventDispatcher
    extends CEventDispatcher
{
    protected   COPSEClient                 pClient;
    protected   COPSEClientEventHandler     pClientEventHandler;
    protected   COPSEClientProjectManager   pProjectManager;

    public COPSEClientEventDispatcher ( COPSEClient client, COPSEClientEventHandler handler )
    {
        super();
        pClient = client;
        pClientEventHandler = handler;
    }


    protected void ProcessEvent( CEvent event )
    {
        System.err.println( "[DEBUG] ClientDispatcher - Event: ["+ event.GetType()
            + "|port:" + event.GetSocketPort() + "|conn:" + event.GetConnectionId() + "]" );

        // For while, it queries the ProjectManager to find who has to receive the event
        pProjectManager = pClient.GetProjectManager();

        if( event.GetSocketPort() == 0 ) // pProjectManager.GetProjectServerPort() )
            pClientEventHandler.AddEvent( event );

        else
            try {
                CQueuedClientManager client = (CQueuedClientManager) pProjectManager.FindClient( event.GetSocketPort(), event.GetConnectionId() );
                if( client != null )
                {
                    System.err.println( "[DEBUG] ClientDispatcher - Sending to a Client..." );
                    client.AddEvent( event );
                }
                else
                    System.err.println( "[DEBUG] ClientDispatcher - Not found target Client to event!" );

            } catch (Exception e) {}
    }

}




/*
public class COPSEClientEventDispatcher
    implements CEventHandler
{
    protected   COPSEClient                 pClient;
    protected   COPSEClientEventHandler     pClientEventHandler;
    protected   COPSEClientProjectManager   pProjectManager;

    public COPSEClientEventDispatcher ( COPSEClient client, COPSEClientEventHandler handler )
    {
        pClient = client;
        pClientEventHandler = handler;
    }

    public void ProcessEvent( CEvent event, CConnectionHandler handler )
    {
        ProcessEvent( event );
    }


    public void ProcessEvent( CEvent event )
    {
        System.err.println( "[DEBUG] ClientDispatcher - Event: ["+ event.GetType()
            + "|port:" + event.GetSocketPort() + "|conn:" + event.GetConnectionId() + "]" );

        // For while, it queries the ProjectManager to find who has to receive the event
        pProjectManager = pClient.GetProjectManager();

        if( event.GetSocketPort() == 0 ) // pProjectManager.GetProjectServerPort() )
            pClientEventHandler.ProcessEvent( event );

        else
            try {
                CQueuedClientManager client = (CQueuedClientManager) pProjectManager.FindClient( event.GetSocketPort(), event.GetConnectionId() );
                if( client != null )
                {
                    System.err.println( "[DEBUG] ClientDispatcher - Sending to a Client..." );
                    client.AddEvent( event );
                }
                else
                    System.err.println( "[DEBUG] ClientDispatcher - Not found target Client to event!" );

            } catch (Exception e) {}
    }


}
*/