/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * COPSE Client Application
 * Classe: COPSEClientProductManager
\******************************************************************************/


import java.io.*;
import java.util.*;


import FILE.*;
import PRODUCT.*;
import COPSE.*;
import COPSE.CONTROL.*;

//import AGENT.*;
//import PROCESS.MODEL.*;
//import PROCESS.*;



public class COPSEClientProductManager
{
    protected   COPSEClientProjectManager   pProjectManager;

    protected   CProduct                    pProduct;

    protected   CFileController             pProductController;
    protected   Vector                      pDocumentControllers;


    public COPSEClientProductManager( COPSEClientProjectManager manager )
    {
        pProjectManager = manager;

        pProduct = null;
        pProductController = null;
        pDocumentControllers = null;

        // Ask COPSEServer to send needed information
        try {
            CEvent event = new CEvent( CEvent.EvCOPSE_ProductManager_Load );
            manager.GetClient().GetConnector().Send( event );
        } catch( Exception e ) {};
    }


    public void SetProduct( CFileController productController, Vector docControllers )
    {
        pProduct = (CProduct) productController.GetFile();
        pProductController = productController;
        pDocumentControllers = docControllers;
    }


    public CDocEntry    FindDocEntry ( int docId )
    {
        if( pProduct == null )
            return null;

        return pProduct.FindDocEntry( docId );
    }


    public CDocumentController  GetDocumentController( int docId )
    {
        if( pDocumentControllers == null )
            return null;

        Enumeration e = pDocumentControllers.elements();
        while( e.hasMoreElements() )
        {
            CDocumentController doc = (CDocumentController) e.nextElement();
            if( doc.GetDocId() == docId )
                return doc;
        }
        return null;
    }

    public void Close()
    {
    }

}
