/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 *
 * Classe: COPSEDlgLogin
 ******************************************************************************/


import java.awt.*;
import java.awt.event.*;


/*************************************************************************
 *  Class COPSEDlgLogin
 *************************************************************************/
public class COPSEDlgLogin
    extends     Dialog
    implements  WindowListener, ActionListener
{
    public TextField   pUserLogin;
    public TextField   pUserPassword;
    public TextField   pServerHost;
    public TextField   pServerPort;

    public Button      btnOk;
    public Button      btnCancel;

    protected COPSEGUIManager pGUI;


    public COPSEDlgLogin( Frame parent, COPSEGUIManager gui )
    {
        super( parent, true );
        pGUI = gui;

		setLayout(null);
		addNotify();

        Point p = parent.getLocation();
        p.translate( 20, 30 );
		setLocation( p );

		Insets insets = getInsets();
		setSize(insets.left + insets.right + 300,insets.top + insets.bottom + 155);
		setFont(new Font("Helvetica", Font.PLAIN, 12));

		Label label;

		label = new Label("Server Host:");
		label.setBounds(insets.left + 14,insets.top + 15,91,15);
		add(label);

		pServerHost = new TextField();
		pServerHost.setBounds(insets.left + 112,insets.top + 15,168,22);
		add(pServerHost);


		label = new Label("Server Port:");
		label.setBounds(insets.left + 14,insets.top +40,91,15);
		add(label);

		pServerPort = new TextField();
		pServerPort.setBounds(insets.left + 112,insets.top + 40,168,22);
		add(pServerPort);


		label = new Label("User Login:");
		label.setBounds(insets.left + 14,insets.top +65,91,15);
		add(label);

		pUserLogin = new TextField();
		pUserLogin.setBounds(insets.left + 112,insets.top + 65,168,22);
		add(pUserLogin);


		label = new Label("User Password:");
		label.setBounds(insets.left + 14,insets.top +90,91,15);
		add(label);

		pUserPassword = new TextField();
		pUserPassword.setBounds(insets.left + 112,insets.top + 90,168,22);
		pUserPassword.setEchoChar( '*' );
		add(pUserPassword);


        btnOk = new Button( "Ok" );
        btnOk.setBounds( insets.left + 60,insets.top + 120, 80, 24 );
        btnOk.addActionListener( this );
        add( btnOk );

        btnCancel = new Button( "Cancel" );
        btnCancel.setBounds( insets.left + 160,insets.top + 120, 80, 24 );
        btnCancel.addActionListener( this );
        add( btnCancel );


        addWindowListener( this );

        setTitle( "COPSE User Login" );
        setResizable( false );
    }



    //* WindowListener methods
    public void windowOpened(WindowEvent e)        {}
    public void windowClosing(WindowEvent e)       {  _Close(false); }
    public void windowClosed(WindowEvent e)        {}
    public void windowIconified(WindowEvent e)     {}
    public void windowDeiconified(WindowEvent e)   {}
    public void windowActivated(WindowEvent e)     {}
    public void windowDeactivated(WindowEvent e)   {}


    //* ActionListener method
    public void actionPerformed( ActionEvent event )
    {
        Object source;

        source = event.getSource();
        if( source == btnOk )
        {
            _Close( true );
        }
        else
        if( source == btnCancel )
        {
            _Close( false );
        }
    }


    protected void _Close( boolean ok )
    {
        setVisible( false );

        if( ok )
        {
            pGUI.OpenClient( pServerHost.getText(), pServerPort.getText(),
                             pUserLogin.getText(), pUserPassword.getText() );
            this.dispose();
        }
        else
            pGUI.Exit();
    }


}