/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * COPSE Client Application
 * Classe:  COPSEClientGUIManager
\******************************************************************************/


import java.awt.*;
import java.awt.event.*;


public class    COPSEGUIProjectManager
    implements  WindowListener , ActionListener
{
    //*
    protected   COPSEGUIManager             pGUI;

    //*
    protected   COPSEClient                 pCOPSEClient;


    // Project Menu
    protected   Menu            mnProject;
    protected   MenuItem        mnProjectAbout;
    protected   MenuItem        mnProjectExit;


    //*
    protected   COPSEGUIProcessControl         pProcessControl;
    protected   COPSEGUIProductControl         pProductControl;
    protected   COPSEGUIPeopleControl          pPeopleControl;
    // ....



    public COPSEGUIProjectManager( COPSEGUIManager gui )
    {
        pGUI = gui;

        pCOPSEClient = null;

        pProcessControl = new COPSEGUIProcessControl( this );
        pProductControl = new COPSEGUIProductControl( this );
        pPeopleControl  = new COPSEGUIPeopleControl( this );


    }


    public void     SetClient( COPSEClient client )
    {
        if( pCOPSEClient != null )
        {
            // Close pCOPSEClient....
        }

        pCOPSEClient = client;

        if( pCOPSEClient != null )
        {
            // Activate Controls...
            /*
            pProcessControl.activate( true );
            pProductControl.activate( true );
            pPeopleControl.activate( true );
            */
        }
    }


    public COPSEGUIManager GetGUIManager()
    {
        return pGUI;
    }

    public void AddMenu( MenuBar menuBar )
    {
        //* Add Project Menu
        mnProject = new Menu( "Project");

        mnProjectAbout = new MenuItem( "About..." );
        mnProjectAbout.addActionListener( this );
        mnProject.add( mnProjectAbout );

        mnProject.addSeparator();

        mnProjectExit = new MenuItem( "Exit All" );
        mnProjectExit.addActionListener( this );
        mnProject.add( mnProjectExit );

        menuBar.add( mnProject );


        //* Add Other menus...
        pProcessControl.AddMenu( menuBar );
        pProductControl.AddMenu( menuBar );
        pPeopleControl.AddMenu( menuBar );
        //...

    }


    //* WindowListener methods
    public void windowOpened(WindowEvent e)        {}
    public void windowClosing(WindowEvent e)       {  _Close(false); }
    public void windowClosed(WindowEvent e)        {}
    public void windowIconified(WindowEvent e)     {}
    public void windowDeiconified(WindowEvent e)   {}
    public void windowActivated(WindowEvent e)     {}
    public void windowDeactivated(WindowEvent e)   {}


    //* ActionListener method
    public void actionPerformed( ActionEvent event )
    {
        Object source = event.getSource();

        if( source == mnProjectAbout )
        { }
        else
        if( source == mnProjectExit )
        {
            _Close( false );
        }
    }




    protected void _Close( boolean save )
    {
        if( pCOPSEClient != null )
        {
            pCOPSEClient.Exit();
            try{
                pCOPSEClient.join();
            } catch(Exception e){};

            pCOPSEClient = null;
        }


        // temporary
        System.exit( 0 );
    }

}