/**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTORA MANUELE KIRSCH PINHEIRO
 * INTERFACE UI_GUIEvent
 * PACOTE INTERFACE
 * DATA DE CRIACAO 15 / 11 / 2000
 */

package BW.Interface;

import BW.Interface.*;
import BW.kernel.BW_Event;

import java.util.Vector;

/**
 * A interface UI_GUIEvent e o elemento responsavel por apresentar
 * os eventos ocorridos para o usuario. Ela deve manter referencia
 * do tipo de evento que apresenta e do UI_GUIElement que a controla.
 * @see UI_GUIElement
 * @author Manuele Kirsch Pinheiro
 * @version 1.0
 */
public interface UI_GUIEvent {

   /** Mensagem solicitando a inclusao de novos eventos aos que ja
    * estao sendo apresentados na GUI
    * @param Vector events	vetor de BW_Events com os eventos a serem incluidos
    * @see BW.kernel.BW_Event
    */	
    public void newEvents(Vector events);

   /** Mensagem exigindo a atualizacao completa da GUI, com a
    * apresentacao do novo conjunto de eventos, passado por parametro
    * @param Vector events	vetor de BW_Events que devem ser apresentados ao usuario
    * @see BW.kernel.BW_Event
    */
    public void update(Vector events);

   /** Seta o elemento de interface (UI_GUIElement) responsavel por este UI_GUIEvent
    * @see UI_GUIElement
    */
    public void setUI_GUIElement(UI_GUIElement control);

   /** Retorna o elemento de interface responsavel por este objeto
    * @see #setUI_GUIElement
    */
    public UI_GUIElement getUI_GUIElement ();

  /** Retorna uma instancia de BW_Event, prototipo indicando o tipo de evento
   * apresentado por esta GUI
   * @see #setEventPrototype
   */
    public BW_Event getEventPrototype();

   /** Seta um evento prototipo, que indicara qual o tipo de evento que esta
    * sendo apresentado por esta GUI
    * @see BW.kernel.BW_Event
    */
    public void setEventPrototype(BW_Event prototype);

}
