 /**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTORA MANUELE KIRSCH PINHEIRO
 * CLASSE MakeBase
 * PACOTE BW
 * DATA DE CRIACAO 31 / 10 / 2000
 * DATA DE ALTERACAO 16 / 05 / 2001
 */

package BW;

import java.net.URL;
import java.sql.*;
import java.util.Vector;

 /**
 * classe MakeBase e a classe responsavel
 * pela construcao da base de dados a ser usada.
 * @author Manuele Kirsch Pinheiro
 * @version 1.2
 */
public class MakeBase {

   public static String query;
   public static Connection con;
   public static Statement stmt;
   public static PreparedStatement  pstmt;
   public static ResultSet  results;

   /**
    * o metodo SelectData faz um SELECT * na tabela passada
    * como parametro.
    * @param String table	tabela para apresentar
    */
   public static void SelectData(String table)
   {
	  try {
       		stmt = con.createStatement();
	        String SQLText = ("select * from " + table);
	        results = stmt.executeQuery( SQLText );
	        DisplayRows( results );
	      }
	  catch (java.lang.Exception ex)
	     {
		// Print description of the exception.
		      System.out.println( "** Error on data select. ** " );
		      ex.printStackTrace ();
	      }
   } //----------- End SelectData


   /**
    * O metado DisplayRows apresenta apenas o nome dos
    * campos e seus tipos.
    * @param	ResultSet results	resultados da consulta	
    * @exception 	SQLException	caso nao se consiga apresentar os resultados
    */
      public static void DisplayRows( ResultSet results )
         throws SQLException
	{
		int i;

		//resgata o descritor de metadados da tabela
                ResultSetMetaData rsmd = results.getMetaData ();

		//busca o numero de colunas
		int numCols = rsmd.getColumnCount ();

		//Imprime os nomes das colunas (cabecalho)
		//COMECA EM 1!!!
  		for (i=1; i<=numCols; i++)
                {
                        if (i > 1) System.out.print(" + ");
			System.out.print(rsmd.getColumnLabel(i));			
                }
                System.out.println("");
		//Imprime o tipo de cada coluna
		//COMECA EM 1!!!
		for (i=1;i<=numCols; i++) {
                      if (i > 1) System.out.print("  |  ");		
                      System.out.print (rsmd.getColumnTypeName(i));		
                }
                System.out.println("");
  	}   //-------------End displayRows

   /**
    * Metodo createTable cria uma tabela com o nome e os campos designados
    * @param	String table	nome da tabela
    * @param 	Vector fields	vetor com as duplas (String)campo (String)tipo para a tabela
    */
   public static void createTable (String table, Vector fields) {
	try {
       		String SQLText = "CREATE TABLE " + table + " (";

                int i=0;
       		while (i<(fields.size()-1)) {
       		    String fname = (String)fields.elementAt(i++);
  		    String ftype = (String)fields.elementAt(i++);
  		    //System.out.println ("creating field "+fname+" "+ftype);
       		    SQLText += fname + " " + ftype;
       		    if (i%2==0 && i<fields.size())
       		        SQLText += ", ";
       		}		
       		SQLText += " )";
       		
		System.out.println ("Executing SQL "+SQLText);       		
       		pstmt = con.prepareStatement (SQLText);

                int ResultCode = pstmt.executeUpdate();

       		//System.out.println( "Created " + ResultCode + "." );
       		//SelectData (table);

		SQLText = "GRANT ALL ON " + table + " TO PUBLIC ";
		System.out.println ("Executing SQL "+SQLText);       		
       		pstmt = con.prepareStatement (SQLText);

                int ResultCodeG = pstmt.executeUpdate();

		System.out.println ("ResultCode: CREATE: "+ResultCode+" GRANT: "+ResultCodeG); 	
		
       		
      } catch (java.lang.Exception ex) {
      		// Print description of the exception.
		System.out.println( "** Error on create table. ** " );
		ex.printStackTrace ();
      }
  } //------ End createTable
  	 	

  /**
   * Metodo initDB inicializa a conexao com o Banco de dados
   * @param	String	url	URL de acesso ao Banco de Dados
   * @param	String 	user	nome do usuario na base da dados
   * @param	String 	passwd	senha a ser usada para conexao
   */
   public static void initDB(String url, String user, String passwd) {
       	try
         {
                    //Le o Drive para o Postgres
                    Class.forName("postgresql.Driver");

                    //tenta conexao
		    System.out.println ("Conecting to "+url+" as "+user+":"+passwd);	
                    con = DriverManager.getConnection (url, user , passwd);
                    System.out.println ("Conected");

         } catch (SQLException ex)
          {
			// An SQLException was generated.  We Catch it and
			// display the error information.  There may be multiple
			// error objects chained together. Let's get them all ok.
			System.out.println ("\n*** SQLException caught ***\n");
			while (ex != null)
                         {
				System.out.println ("SQLState: " +
					ex.getSQLState ());
				System.out.println ("Message:  " +
					ex.getMessage ());
				System.out.println ("Vendor:   " +
					ex.getErrorCode ());
				ex = ex.getNextException ();
				System.out.println ("");
			}
	} catch (java.lang.Exception ex)
          {
			// Got some other type of exception.  Lets look it over.
			ex.printStackTrace ();
	  }
	 		


   } //initDB


   public static void main (String argv[]) {
		String url= new String("jdbc:postgresql:");
		String dbname = new String ("bw");
		String host=""; boolean bhost=false;
            	String port=""; boolean bport=false;
		String user="";
		String passwd="";

                if (argv.length>=2) {
                    // argumentos: -u user [-h host] [-p port] [-s passwd] [-d database] [-? ]
                    for (int i=0; i<argv.length;i++){
                    	String arg = argv[i];
                    	if (arg.charAt(0)=='-') {
                    		switch (arg.charAt(1)) {
                    			case 'u':
                    				user = new String (argv[i+1]);
                    		                break;
                    		        case 'h':
                    				host = new String (argv[i+1]);
                    				bhost = true;
                    		                break;                    		        	
                    			case 'd':
                    				dbname = new String (argv[i+1]);
                    		                break;

                    		        case 'p':
                    				port = new String (argv[i+1]);
                    				bport = true;
                    		                break;                    		        	                    		
                    		        case 's':
                    				passwd = new String (argv[i+1]);
                    		                break;       
					case '?':
                  				System.out.println ("java BW.MakeBase -u user [-h host] [-d database] [-p port] [-s passwd ] ");
						System.out.println ("java BW.MakeBase -? ");
						System.exit(0);
                    		}
                    	 }
                    }//fim for	

                    if (bhost) {
                       url += "//";
                       url += host;
                       if (bport) {
                       	  url += ":";
                       	  url += port;
                       }
                       url+= "/";
                    }
                }
		else {
                  	System.out.println ("java BW.MakeBase -u user [-h host] [-d database] [-p port] [-s passwd ] ");
			System.out.println ("java BW.MakeBase -? ");
			System.exit(0);
		}

                url += dbname;
                initDB (url,user,passwd);

                //criando as tabelas
                Vector fields;
                String table;

                //tabela EVENT
                table = "T_EVENT";
                System.out.println ("Creating table "+table);
                fields = t_event();
                createTable (table,fields);

                //tabela REGISTER
                table = "T_REGISTER";
                System.out.println ("Creating table "+table);
                fields = t_register();
                createTable (table,fields);

                //tabela MEMBER
                table = "T_MEMBER";
                System.out.println ("Creating table "+table);
                fields = t_member();
                createTable (table,fields);

                //tabela GROUP
                table = "T_GROUP";
                System.out.println ("Creating table "+table);
                fields = t_group();
                createTable (table,fields);

                //tabela PAPER
                table = "T_PAPER";
                System.out.println ("Creating table "+table);
                fields = t_paper();
                createTable (table,fields);

                //tabela PROFILE
                table = "T_PROFILE";
                System.out.println ("Creating table "+table);
                fields = t_profile();
                createTable (table,fields);

                //tabela PROFILE_EVENT
                table = "T_PROFILE_EVENT";
                System.out.println ("Creating table "+table);
                fields = t_profile_event();
                createTable (table,fields);

                //tabela MEMBER_PAPER
                //DESNECESSARIA - INFORMACAO OBTIDA JUNTO COM O AWARENESSPROFILE
                /* table = "T_MEMBER_PAPER";
                System.out.println ("Creating table "+table);
                fields = t_member_paper();
                createTable (table,fields);
                */

                //tabela SETUP
                table = "T_SETUP";
                System.out.println ("Creating table "+table);
                fields = t_setup();
                createTable (table,fields);

                //tabela PROFILE_PERSONAL
                table = "T_PROFILE_PERSONAL";
                System.out.println ("Creating table "+table);
                fields = t_profile_personal();
                createTable (table,fields);

                //tabela PROFILE_PERSONAL_PAPER
                table = "T_PROFILE_PERSONAL_PAPER";
                System.out.println ("Creating table "+table);
                fields = t_profile_personal_paper();
                createTable (table,fields);

                //tabela GROUP_MEMBER
                table = "T_GROUP_MEMBER";
                System.out.println ("Creating table "+table);
                fields = t_group_member();
                createTable (table,fields);

                //tabela GROUP_PAPER
                table = "T_GROUP_PAPER";
                System.out.println ("Creating table "+table);
                fields = t_group_paper();
                createTable (table,fields);


   }

     /** cria a tabela para os eventos */
     public static Vector t_event () {
     		Vector fields = new Vector();
                fields.addElement ("typeid"); fields.addElement ("int2");
                fields.addElement ("objid"); fields.addElement ("int2");
		fields.addElement ("name"); fields.addElement ("text");
                fields.addElement ("description"); fields.addElement ("text");
                fields.addElement ("details"); fields.addElement ("text");		
                fields.addElement ("MEMBER_typeid"); fields.addElement ("int2");
                fields.addElement ("MEMBER_objid"); fields.addElement ("int2");
                fields.addElement ("bg"); fields.addElement ("int8");
                fields.addElement ("ed"); fields.addElement ("int8");
                fields.addElement ("tmz"); fields.addElement ("text");
                fields.addElement ("lcl"); fields.addElement ("text");		
                return fields;
     }


     /** cria a tabela para os membros */
     public static Vector t_member () {
     		Vector fields = new Vector();
                fields.addElement ("typeid"); fields.addElement ("int2");
                fields.addElement ("objid"); fields.addElement ("int2");
                fields.addElement ("name"); fields.addElement ("text");
                fields.addElement ("login"); fields.addElement ("text");		
                fields.addElement ("mail"); fields.addElement ("text");
                fields.addElement ("homepage"); fields.addElement ("text");		
                fields.addElement ("machine"); fields.addElement ("text");		
                fields.addElement ("PROFILE_typeid"); fields.addElement ("int2");
                fields.addElement ("PROFILE_objid"); fields.addElement ("int2");
                fields.addElement ("bg"); fields.addElement ("int8");
                fields.addElement ("ed"); fields.addElement ("int8");
                fields.addElement ("tmz"); fields.addElement ("text");
                fields.addElement ("lcl"); fields.addElement ("text");		
                return fields;
     }

     /** cria a tabela para os grupos */
     public static Vector t_group () {
     		Vector fields = new Vector();
                fields.addElement ("typeid"); fields.addElement ("int2");
                fields.addElement ("objid"); fields.addElement ("int2");
                fields.addElement ("name"); fields.addElement ("text");
                fields.addElement ("description"); fields.addElement ("text");		
                return fields;
     }

     /** cria a tabela para os papeis */
     public static Vector t_paper () {
     		Vector fields = new Vector();
                fields.addElement ("typeid"); fields.addElement ("int2");
                fields.addElement ("objid"); fields.addElement ("int2");
                fields.addElement ("level"); fields.addElement ("int2");
                fields.addElement ("name"); fields.addElement ("text");		
                fields.addElement ("description"); fields.addElement ("text");		
                fields.addElement ("PROFILE_typeid"); fields.addElement ("int2");
                fields.addElement ("PROFILE_objid"); fields.addElement ("int2");
                return fields;
     }

     /** cria a tabela para os profiles */
     public static Vector t_profile () {
     		Vector fields = new Vector();
                fields.addElement ("typeid"); fields.addElement ("int2");
                fields.addElement ("objid"); fields.addElement ("int2");
                fields.addElement ("bg"); fields.addElement ("int8");
                fields.addElement ("ed"); fields.addElement ("int8");
                fields.addElement ("tmz"); fields.addElement ("text");
                fields.addElement ("lcl"); fields.addElement ("text");		
                return fields;
     }

     /** cria a tabela para a relacao eventos-profiles */
     public static Vector t_profile_event () {
     		Vector fields = new Vector();
                fields.addElement ("PROFILE_typeid"); fields.addElement ("int2");
                fields.addElement ("PROFILE_objid"); fields.addElement ("int2");
                fields.addElement ("EVENT_typeid"); fields.addElement ("int2");
                //o q me interessa eh uma instancia prototipo - nao um evento real
                //fields.addElement ("EVENT_objid"); fields.addElement ("int2");
                fields.addElement ("EVENT_classname"); fields.addElement ("text");
                return fields;
     }

     /** cria a tabela para a relacao member-paper
     public static Vector t_member_paper () {
     		Vector fields = new Vector();
                fields.addElement ("MEMBER_typeid"); fields.addElement ("int2");
                fields.addElement ("MEMBER_objid"); fields.addElement ("int2");
                fields.addElement ("PAPER_typeid"); fields.addElement ("int2");
                fields.addElement ("PAPER_objid"); fields.addElement ("int2");
                //fields.addElement ("GROUP_typeid"); fields.addElement ("int2");
                //fields.addElement ("GROUP_objid"); fields.addElement ("int2");
                //fields.addElement ("PROFILE_typeid"); fields.addElement ("int2");
                //fields.addElement ("PROFILE_objid"); fields.addElement ("int2");

                return fields;
     }
     */

     /** cria a tabela de setup */
     public static Vector t_setup () {
     		Vector fields = new Vector();
                fields.addElement ("server");	fields.addElement ("text");
                fields.addElement ("isServer");	fields.addElement ("bool");
                fields.addElement ("timelife");	fields.addElement ("int2");
                fields.addElement ("lastObjId");fields.addElement ("int2");
                fields.addElement ("port");	fields.addElement ("int2");
                return fields;
     }


     /** cria a tabela para a relacao group-member */
     public static Vector t_group_member () {
     		Vector fields = new Vector();
     		fields.addElement ("GROUP_typeId");	fields.addElement ("int2");
     		fields.addElement ("GROUP_objId");	fields.addElement ("int2");     		
                fields.addElement ("MEMBER_typeid");	fields.addElement ("int2");
                fields.addElement ("MEMBER_objid"); 	fields.addElement ("int2");
                return fields;
    }


     /** cria a tabela para a relacao group-paper */
     public static Vector t_group_paper () {
     		Vector fields = new Vector();
     		fields.addElement ("GROUP_typeId");	fields.addElement ("int2");
     		fields.addElement ("GROUP_objId");	fields.addElement ("int2");     		
                fields.addElement ("PAPER_typeid");	fields.addElement ("int2");
                fields.addElement ("PAPER_objid"); 	fields.addElement ("int2");
                return fields;
    }


     /** cria a tabela para a relacao register */
     public static Vector t_register () {
     		Vector fields = new Vector();
     		fields.addElement ("typeId");	fields.addElement ("int2");
     		fields.addElement ("objId");	fields.addElement ("int2");     		
                fields.addElement ("EVENT_typeid");	fields.addElement ("int2");
                fields.addElement ("EVENT_classname"); 	fields.addElement ("text");
                return fields;
    }

     /** cria a tabela para a relacao profile-personal */
     public static Vector t_profile_personal () {
     		Vector fields = new Vector();
     		fields.addElement ("typeId");	fields.addElement ("int2");
     		fields.addElement ("objId");	fields.addElement ("int2");     		
                fields.addElement ("PROFILE_typeid");	fields.addElement ("int2");
                fields.addElement ("PROFILE_objid"); 	fields.addElement ("int2");
                return fields;
    }

     /** cria a tabela para a relacao profile-personal-paper */
     public static Vector t_profile_personal_paper () {
     		Vector fields = new Vector();
     		fields.addElement ("typeId");	fields.addElement ("int2");
     		fields.addElement ("objId");	fields.addElement ("int2");     		
                fields.addElement ("PROFILE_typeid");	fields.addElement ("int2");
                fields.addElement ("PROFILE_objid"); 	fields.addElement ("int2");
                fields.addElement ("PAPER_typeid");	fields.addElement ("int2");
                fields.addElement ("PAPER_objid"); 	fields.addElement ("int2");
                return fields;
    }

}
