/**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTORA MANUELE KIRSCH PINHEIRO
 * CLASSE FC_ST_MONITOR
 * PACOTE BW.STORAGE
 * DATA DE CRIACAO 21 / 07 / 2000
 */

package BW.storage;

import BW.kernel.*;
import BW.control.*;

import java.util.Vector;
//import java.util.Hashtable;


/**
 * classe FC_ST_Momitor faz o interfaceamento entre
 * as camadas de controle (pacote control) e a
 * camada de armazenamento (pacote storage).
 * @autor Manuele K P
 * @version 1.0
 */
public class FC_ST_Monitor {

	///////////////////////////////////////
	////// FALTA MUITA COISA AINDA  //////
	//////////////////////////////////////

	
	////////////////////////// ATRIBUTOS //////////////////////////////////////
	
	/** objeto de controle, responsavel por quase todo o processamento da camada
	 * de armazenamento, representada pelo pacote Storage
	 */
	ST_Controler control;
	
	/** objeto estrategista, responsavel pela abstracao da base de dados real. */
	ST_Strategist strgy;
	
	
	
	////////////////////////// CONSTRUTOR /////////////////////////////////////
	
	public FC_ST_Monitor () {
		control = null;
		strgy = null;
	}
	
	
	/////////////////////////// METODOS ////////////////////////////////////
	
	
	/////////////////// SAVES
	
	/** executa um statement SQL junto a base de dados
	 * @param 	String sql	String com o statement SQL
	 * @return	boolean		true se o statement foi executado com sucesso,
	 *				false, caso contrario.
	 */
	public boolean save (String sql) {
		boolean ret = false;
		try {
			ret = this.control.save (sql);
		}catch (Exception e) {
		
		}
		return ret;
	}

		
	/** demanda o armazenamento do registro de eventos junto a base de dados
	 * @param 	BW_Register what	BW_Register a ser armazenado
	 * @return	boolean			true se as informacoes foram armazenadas,
	 *					false se nao o foram.
	 */
	public boolean save (BW_Register what) {
		boolean ret = false;
		try {
			ret = this.control.save (what);
		}catch (Exception e) {
		
		}
		return ret;
	}
	
		
	/** demanda o armazenamento de um grupo junto a base de dados
	 * @param 	BW_Group what	BW_Group a ser armazenado
	 * @return	boolean		true se as informacoes foram armazenadas,
	 *				false se nao o foram.
	 */
	public boolean save (BW_Group what) {
		boolean ret = false;
		try {
			ret = this.control.save (what);
		}catch (Exception e) {
		
		}
		return ret;
	}
	
		
	/** demanda o armazenamento de um papel isolado junto a base de dados
	 * @param 	BW_Paper what	BW_Paper a ser armazenado
	 * @return	boolean		true se as informacoes foram armazenadas,
	 *				false se nao o foram.
	 */
	public boolean save (BW_Paper what) {
		boolean ret = false;
		try {
			ret = this.control.save (what);
		}catch (Exception e) {
		
		}
		return ret;
	}
	
		
	/** demanda o armazenamento de um membro isolado junto a base de dados
	 * @param 	BW_Member what	BW_Member a ser armazenado
	 * @return	boolean		true se as informacoes foram armazenadas,
	 *				false se nao o foram.
	 */
	public boolean save (BW_Member what) {
		boolean ret = false;
		try {
			ret = this.control.save (what);
		}catch (Exception e) {
		
		}
		return ret;
	}
	
		
	/** demanda o armazenamento de um unico evento isolado junto a base de dados
	 * @param 	BW_Event what	BW_Event a ser armazenado
	 * @return	boolean		true se as informacoes foram armazenadas,
	 *				false se nao o foram.
	 */
	public boolean save (BW_Event what) {
		boolean ret = false;
		try {
			ret = this.control.save (what);
		}catch (Exception e) {
		
		}
		return ret;
	}
	
		
	/** demanda o armazenamento de um elemento generico isolado junto a base de dados
	 * @param 	BW_Element what	BW_Element a ser armazenado
	 * @return	boolean		true se as informacoes foram armazenadas,
	 *				false se nao o foram.
	 */
	public boolean save (BW_Element what) {
		boolean ret = false;
		try {
			ret = this.control.save (what);
		}catch (Exception e) {
		
		}
		return ret;
	}
	
		
	/** demanda o armazenamento de um conjunto de elementos junto a base de dados.
	 * Este conjunto deve conter somente objetos de subclasses BW_Element ou da propria,
	 * mas estes objetos podem ser de diferentes classes.
	 * @param 	Vector what	conjunto de informacoes a ser armazenado
	 * @return	boolean		true se as informacoes foram armazenadas,
	 *				false se nao o foram.
	 */
	public boolean save (Vector what) {
		boolean ret = true;
		try {
			this.control.save (what);
		}catch (Exception e) {
	            ret = false;
		}		
		return ret;
	}
	
	
	/** envia para o armazenamento um vetor exclusivamente composto por
	 *  instancias de BW_Event (ou de subclasses desta).
	 * @param	Vector what	vetor de eventos a serem salvos
	 * @return	boolean		true se a operacao ocorreu sem problemas
	 */
	public boolean saveEvents (Vector what)	{
		boolean ret = false;
		try {
			ret = this.control.saveEvents (what);
		} catch (Exception e) {
			ret = false;
		}
		
		return ret;
	}

		
	/** demanda o armazenamento das informacoes de setup do sistema
	 */
	public void saveSetup () {
		try {			
			this.control.saveSetup ();
		}catch (Exception e) {
		
		}
	}
	
	
	
	/////////////////// READS UNICOS
	
	
	/** executa uma QUERY SQL junto a base de dados
	 * @param 	String sql	query a ser executada
	 * @return	Vector 		resultados lidos da query (poder ser null)
	 */
	public Vector read (String sql) {
		Vector ret = null;
		try {
			ret = this.control.read (sql);
		} catch (Exception e) {
			ret = null;
		}
		return ret;
	}
	
	
	/** faz a carga atualizada de uma instancia de BW_Register
	 * @param	BW_Register what	instancia a ser atualizada
	 * @return	BW_Register		instancia lida da base de dados
	 */
	public BW_Register read (BW_Register what) {
		BW_Register ret = null;
		try {
			ret = this.control.read (what);
		} catch (Exception e) {
			ret = null;
		}
		return ret;
	}
	
	
	/** faz a carga atualizada de uma instancia de BW_Group
	 * @param	BW_Group what	instancia a ser atualizada
	 * @return	BW_Group	instancia lida da base de dados
	 */
	public BW_Group read (BW_Group what) {
		BW_Group ret = null;
		try {
			ret = this.control.read (what);
		} catch (Exception e) {
			ret = null;
		}
		return ret;
	}
	
	                               	
	/** faz a carga atualizada de uma unica instancia de BW_Paper
	 * @param	BW_Paper what	instancia a ser atualizada
	 * @return	BW_Paper	instancia lida da base de dados
	 */
	public BW_Paper read (BW_Paper what) {
		BW_Paper ret = null;
		try {
			ret = this.control.read (what);
		} catch (Exception e) {
			ret = null;
		}
		return ret;
	}
	
	
	/** faz a carga atualizada de uma unica instancia de BW_Member
	 * @param	BW_Member what	instancia a ser atualizada
	 * @return	BW_Member	instancia lida da base de dados
	 */
	public BW_Member read (BW_Member what) {
		BW_Member ret = null;
		try {
			ret = this.control.read  (what);
		} catch (Exception e) {
			ret = null;
		}
		return ret;
	}
	

		
	/** faz a carga atualizada de uma unica instancia generica de BW_Element
	 * @param	BW_Element what	instancia a ser atualizada
	 * @return	BW_Element	instancia lida da base de dados
	 */
	public BW_Element read (BW_Element what) {
		BW_Element ret = null;
		try {
			ret = this.control.read (what);
		} catch (Exception e) {
			ret = null;
		}
		return ret;
	}
	
		
	/** faz a carga atualizada de um unico evento ocorrido
	 * @param	BW_Event what	instancia a ser atualizada
	 * @return	BW_Event	instancia lida da base de dados
	 */
	public BW_Event read (BW_Event what) {
		BW_Event ret = null;
		try {
			ret = this.control.read (what);
		} catch (Exception e) {
			ret = null;
		}
		return ret;
	}
	
	
        /** demanda a re-leitura das informacoes de setup do sistema */
        public void readSetup () {
        	try {
        		this.control.readSetup();
        	} catch (Exception e) {
        	
        	}
        }


	
	///////////////////  READS EM GRUPO
	
	/** Le todas as instancias armazenadas de registro,
	 * segundo o identificador de tipo passado na instancia modelo
	 * @param	BW_Register what	instancia modelo, com o typeid setado
	 * @return	Vector 			instancias lidas
	 **/
	public Vector readAll (BW_Register what) {
		Vector ret = null;
		try {
			ret = this.control.readAll (what);
		} catch (Exception e) {
		
		}
		return ret;	
	}
	
	/** Le todas as instancias de grupo armazenadas,
	 * segundo o identificador de tipo passado na instancia modelo
	 * @param	BW_Group what	instancia modelo, com o typeid setado
	 * @return	Vector 		instancias lidas
	 **/
	public Vector readAll (BW_Group what) {
		Vector ret = null;
		try {
			ret = this.control.readAll (what);
		} catch (Exception e) {
		
		}
		return ret;	
	}
	
	/** Le todos papeis armazenados, segundo o identificador de
	 * tipo passado na instancia modelo
	 * @param	BW_Paper what	instancia modelo, com o typeid setado
	 * @return	Vector 		instancias lidas
	 **/
	public Vector readAll (BW_Paper what) {
		Vector ret = null;
		try {
			ret = this.control.readAll (what);
		} catch (Exception e) {
		
		}
		return ret;	
	
	}
	
	/** Le todos os membros armazenadas, segundo o identificador
	 * de tipo passado na instancia modelo.
	 * @param	BW_Member what	instancia modelo, com o typeid setado
	 * @return	Vector 		instancias lidas
	 **/
	public Vector readAll (BW_Member what) {
		Vector ret = null;
		try {
			ret = this.control.readAll (what);
		} catch (Exception e) {
		
		}
		return ret;		
	}

		
	/** Le, de forma generica, todas as instancias armazenadas
	 * de um determinado tipo, identificado pelo typeid da instancia modelo.
	 * @param	BW_Element what	instancia modelo, com o typeid setado
	 * @return	Vector 		instancias lidas
	 **/
	public Vector readAll (BW_Element what) {
		Vector ret = null;
		try {
			ret = this.control.readAll (what);
		} catch (Exception e) {
		
		}
		return ret;	
	
	}
	
	
	/** Le todas as instancias armazenadas de um determinado tipo
	 * de evento, segundo o identificador de tipo passado na instancia modelo
	 * @param	BW_Event what	instancia modelo, com o typeid setado
	 * @return	Vector 		instancias lidas
	 **/
	public Vector readAll (BW_Event what) {
		Vector ret = null;
		try {
			ret = this.control.readAll (what);
		} catch (Exception e) {
		
		}
		return ret;		
	}
	

	
	//////////////////// READS POR TEMPO
	
	/** faz a leitura de todos os membros, de um determinado tipo, que
	 *  estiveram ativos pela ultima vez no sistema dentro do periodo
	 *  indicado pelo intervalo passado.
	 * @param	BW_Member what		instancia modelo, com o identificador do tipo desejado
	 * @param 	BW_TimeInterval when	intervalo de interesse
	 * @return	Vector			vetor com as instancias recuperadas
	 */
        public Vector readByTime (BW_Member what, BW_TimeInterval when) {
        	Vector ret = null;
        	try {
        		ret = this.control.readByTime (what, when);
        	}catch (Exception e) {
        	
        	}
        	return ret;
        }
	
	/** faz a leitura de todos os eventos, de um determinado tipo, que
	 *  ocorreram dentro do periodo indicado pelo intervalo passado.
	 * @param	BW_Event what		instancia modelo, com o identificador do tipo desejado
	 * @param 	BW_TimeInterval when	intervalo de interesse
	 * @return	Vector			vetor com as instancias recuperadas
	 */
        public Vector readByTime (BW_Event what, BW_TimeInterval when) {
        	Vector ret = null;
        	try {
        		ret = this.control.readByTime (what, when);
        	}catch (Exception e) {
        	
        	}
        	return ret;
        }

	/** faz a leitura de todos os profiles, de um determinado tipo, que
	 *  possuem o intervalo de interesse dentro do periodo
	 *  indicado pelo intervalo passado.
	 * @param	BW_Profile what		instancia modelo, com o identificador do tipo desejado
	 * @param 	BW_TimeInterval when	intervalo de interesse
	 * @return	Vector			vetor com as instancias recuperadas
	 */
        public Vector readByTime (BW_Profile what, BW_TimeInterval when) {
        	Vector ret = null;
        	try {
        		ret = this.control.readByTime (what, when);
        	}catch (Exception e) {
        	
        	}
        	return ret;
        }
        	


	///////////////////// READS EVENTOS
	
	/** Le todos os eventos que sao de interesse do profile passado.
	 * @param	BW_Profile what		profile descrevendo os tipos de eventos
	 *					e o intervalo de interesse.
	 * @return	Vector			todos os eventos lidos
	 */
	public Vector readEvents (BW_Profile what) {
		Vector ret = null;
		try {
			ret = this.control.readEvents (what);
		} catch (Exception e) {
		
		}
		return ret;
	
	}
	
	
	///////////////////// SET E GET

        public void setControler (ST_Controler ctl) {
        	this.control = ctl;	
        }

        public void setStrategist (ST_Strategist stg) {
		this.strgy = stg;
        }

   	public ST_Controler getControler () {
   		return this.control;
   	}
   	
   	public ST_Strategist getStrategist () {
   		return this.strgy;
   	}
   	
   	
   	////////////////////////// OUTROS
   	
   	public void close () {
   	   try {
   		this.strgy.close();   		
   	   } catch (Exception e) {
   	   }	
   	}
   	
   	public void reOpen () {
   	   try {
   	   	this.strgy.reOpen();
   	   } catch (Exception e) {
   	
   	   }
   	}
   	
   	public boolean isOpen () {
   	  boolean ret = false;
   	  try {
   	  	ret = this.strgy.getStatus();   	  	
   	  } catch (Exception e) {
   		ret = false;
   	  }
   	  return ret;
   	}
}