/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: COPSE
 * Classe:  CEvent
\******************************************************************************/

package COPSE;

import java.io.*;
import java.util.*;


public class CEvent
    implements Serializable
{

    //***  General COPSE Events  *********************************************************
    public static final int     EvCOPSE_Server_Init                     =  50;
    public static final int     EvCOPSE_Server_Exit                     =  51;


    public static final int     EvCOPSE_FileController_Load             =  60;
    public static final int     EvCOPSE_FileController_Element_Lock     =  61;
    public static final int     EvCOPSE_FileController_Element_Unlock   =  62;
    public static final int     EvCOPSE_FileController_Element_New      =  63;
    public static final int     EvCOPSE_FileController_Element_Delete   =  64;
    public static final int     EvCOPSE_FileController_Element_Visual   =  65;
    public static final int     EvCOPSE_FileController_Element_Update   =  66;
    public static final int     EvCOPSE_FileController_Save             =  67;
    public static final int     EvCOPSE_FileController_Export           =  68;    

    public static final int     EvCOPSE_SessionManager_Load             =  70;


    public static final int     EvCOPSE_ProductManager_Load             =  80;
    public static final int     EvCOPSE_UsersManager_Load               =  81;


    //***  Connection Releated Events  ***************************************************
    public static final int     EvCOPSE_Connection_Error        = 100;
        //  UMgr To Client:   Error on User Connection Request  (1 arg : ErrorMessage)

    public static final int     EvCOPSE_Connection_Open         = 101;
        //  Client to UMgr:             Request connection      (2 args: Login, Password)
        //  UMgr to Client:             Notify sb logged in     (1 arg : UserId)
        //  Client to Server:           Request Connection      (1 arg : UserId)
        //  Server to this client:      Answer request          (1 arg : connId)
        //  Server to other clients:    Notify sb logged in     (1 arg : connId)

    public static final int     EvCOPSE_Connection_Close        = 102;
        //  UMgr to Client:             Notify sb logged out    (1 arg : UserId)
        // Client to UMgr:              Close connection        (0 args)



    //***  Process Manager and Process Server Events  ************************************
    public static final int     EvCOPSE_ProcessManager_ServerSocket         = 150;

    //public static final int     EvProcessServer_Process_Load                = 200;
        //  Client to Server:   Request Process
    public static final int     EvProcessServer_ProcessUsersSession_Load    = 201;
        //  Client to Server:   Request "Process Users Session"
        //  ... ie, where (which activities) the users are working in the process



    //***  Collaboration Events  *********************************************************
    public static final int     EvCollaboration_First                               = 500;

    public static final int     EvCollaboration_Communication_Call_Message          = 510;
    public static final int     EvCollaboration_Communication_Chat_Message          = 515;

//    public static final int     EvCollaboration_Awareness_Telepointer_Request       = 520;
//    public static final int     EvCollaboration_Awareness_Telepointer_Release       = 521;

    public static final int     EvCollaboration_Awareness_Pointer_First             = 520;
    public static final int     EvCollaboration_Awareness_Pointer_On                = 520;
    public static final int     EvCollaboration_Awareness_Pointer_Off               = 521;
    public static final int     EvCollaboration_Awareness_Pointer_Position          = 522;
    public static final int     EvCollaboration_Awareness_Pointer_Last              = 522;

    public static final int     EvCollaboration_Awareness_Screen_First              = 530;
//    public static final int     EvCollaboration_Awareness_Screen_On               = 530;
//    public static final int     EvCollaboration_Awareness_Screen_Off              = 531;
    public static final int     EvCollaboration_Awareness_Screen_Position           = 532;
    public static final int     EvCollaboration_Awareness_Screen_Load               = 533;
    public static final int     EvCollaboration_Awareness_Screen_Last               = 533;


    public static final int     EvCollaboration_Last                                = 550;

    //************************************************************************************







    //***  UML Diagram Editor  ***********************************************************
    public static final int     EvUMLEditor_Class_Position                          = 601;
//    public static final int     EvUMLEditor_Class_Update                            = 602;

    public static final int     EvUMLEditor_Relation_Position                       = 611;
//    public static final int     EvUMLEditor_Relation_Update                         = 612;

    //************************************************************************************









    int     mSocketPort;
    int     mConnectionId;

    int     mTypeId;        // Identifier of the Event Type
    Vector  pArgs;
    // ...

    public CEvent( int type )
    {
        mTypeId = type;
        mSocketPort = mConnectionId = 0;
        pArgs = new Vector();
    }

    public int  GetType             ()              { return mTypeId; }

    public int  GetSocketPort       ()              { return mSocketPort;  }
    public int  GetConnectionId     ()              { return mConnectionId; }

    public void SetSocketPort       ( int port )    { mSocketPort = port;  }
    public void SetConnectionId     ( int conn )    { mConnectionId = conn; }


    public void AddArgument( Serializable obj )
    {   pArgs.addElement( obj );  }


    public Enumeration  GetArguments()
    {   return pArgs.elements();  }


    public Object GetArgumentAt( int i )
    {
        try {
            return pArgs.elementAt(i);
        } catch (Exception e) {}

        return null;
    }

}
