/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * package: COPSE
 * class:  CEventHandler
\******************************************************************************/

package COPSE;

import java.util.*;


public class CEventHandler
    extends Thread
{
    private Vector      pEvents;

    public CEventHandler()
    {
        pEvents = new Vector();
    }

    public final void AddEvent( CEvent event )
    {
        AddEvent( event, null );
    }

    public final void AddEvent( CEvent event, CConnectionHandler handler )
    {
        synchronized( pEvents )
        {
            System.err.println( "[DEBUG] CEventHandler - Queueing event:["+event.GetType()+"|port:"+event.GetSocketPort()+"|conn:"+event.GetConnectionId()+"]" );
            pEvents.addElement( event );
            pEvents.addElement( handler );
            pEvents.notifyAll();
        }
    }

    public final void run ()
    {
        while( true )
        {
            CEvent event;
            CConnectionHandler handler;

            synchronized( pEvents )
            {
                System.err.println( "[DEBUG] CEventHandler - Waiting for event.." );
                while( pEvents.isEmpty() )
                {
                    try {
                        pEvents.wait(100);
                    } catch (InterruptedException ie)
                    {}
                }

                //System.err.println( "[DEBUG] CEventHandler - Receiving an event.." );
                if( pEvents.size() < 2 )
                {
                    pEvents.removeAllElements();
                    continue;
                }

                //System.err.println( "[DEBUG] CEventHandler - Dequeuing event ..." );
                try {
                    event = (CEvent) pEvents.elementAt(0);
                    handler = (CConnectionHandler) pEvents.elementAt(1);
                } catch ( Exception e )
                {
                    e.printStackTrace( System.err );
                    pEvents.removeElementAt(1);
                    pEvents.removeElementAt(0);
                    continue;
                }

                pEvents.removeElementAt(1);
                pEvents.removeElementAt(0);
            }

            //System.err.println( "[DEBUG] CEventHandler - Processing event.." );
            ProcessEvent( event, handler );

        } // while(true)

    }


    protected void ProcessEvent( CEvent event, CConnectionHandler handler )
    {
        ProcessEvent( event );
    }

    protected void ProcessEvent( CEvent event )
    {
        // do nothing...
    }

}


/*
public interface CEventHandler
{
    public      void AddEvent( CEvent event, CConnectionHandler handler );
    protected   void ProcessEvent( CEvent event, CConnectionHandler handler );
}

/*
public interface CEventHandler
{
    public void ProcessEvent( CEvent event, CConnectionHandler handler );
}
*/