/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: COPSE.CLIENT
 * Classe:  CQueuedClientManager
\******************************************************************************/

package COPSE.CLIENT;

import java.io.*;
import java.util.*;
import java.net.*;


import COPSE.*;
import FILE.*;


public class CQueuedClientManager
    extends CClientManager
{
    protected static CEventConnector      pCOPSEClientConnector;

    Vector                      pEvents;

    public static CQueuedClientManager New( int userId, String host, int port, CEventConnector globalClientConnector )
        throws IOException
    {
        pCOPSEClientConnector = globalClientConnector;
        return new CQueuedClientManager( userId, host, port );
    }


    protected CQueuedClientManager( int userId, String host, int port )
        throws IOException
    {
        super(userId, host, port);
    }

    protected void CreateConnectionToServer ( String host, int port )
    {
        System.err.println( "[DEBUG] CQueuedClientManager - creating eventQueueConnector to server..." );
        pServerConnector = new CEventQueueConnector( port, 0, pCOPSEClientConnector );
/*
        System.err.println( "[DEBUG] CClient - creating client socket..." );
        Socket pSocket = new Socket( host, port );
        System.err.println( "[DEBUG] CClient - creating client socket object streams..." );
        pServerConnector = CSocketStreamConnector.New( pSocket, false );
        System.err.println( "[DEBUG] CClient - created client socket streams" );
*/
    }

    public void AddEvent( CEvent event )
    {
        ((CEventQueueConnector)pServerConnector).AddEvent( event );
    }



    protected void SetConnectionId( int connId )
    {
        super.SetConnectionId( connId );
        ((CEventQueueConnector)pServerConnector).SetConnectionId( connId );
    }


}
