/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: COPSE.CLIENT
 * Classe:  CGUIControl
\******************************************************************************/

package COPSE.CLIENT.GUI;

import  COPSE.*;
import  COPSE.CLIENT.*;


public class CGUIControl
    extends  CEventHandler
{
    protected   CGUIManager     pGUI;
    protected   boolean         mIsEnabled;

    public CGUIControl  (CGUIManager gui)
    {
        pGUI = gui;
        //start();
        mIsEnabled = false;
    }

    public void SetEnabled( boolean enable )
    {
        if( mIsEnabled == enable ) return;

        mIsEnabled = enable;

        if( isAlive() )
        {
            if( mIsEnabled )
                resume();
            else
                suspend();
        }
        else
            if( mIsEnabled )
                start();
    }

    public boolean IsEnabled()  { return mIsEnabled; }

    public void Activate()
    {
        SetEnabled( true );
    }

    public void Update()        {}

    public void Exit()
    {
        stop();
    }

}


