/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: COPSE.CONTROL
 * Classe:  CElementController
\******************************************************************************/

package COPSE.CONTROL;

import java.io.*;
import java.util.*;
import java.net.*;

import FILE.*;


public class CElementController
    implements Serializable
{
    protected CElement      pElement;

    protected boolean       pLocked;        // if the element is locked
    protected int           pConnectionId;  // The connection that locked the element
    protected boolean       pChanged;       // If this elements has changed during locking period


    public CElementController( CElement elem )
    {
        pElement = elem;

        pLocked = false;
        pChanged = false;
        pConnectionId = 0;
    }


    public CElement GetElement ()       { return( pElement ); }

    public boolean IsLocked()           { return( pLocked ); }

    public boolean IsChanged()          { return( pChanged ); }

    public int GetLockerConnectionId()  { return( pConnectionId ); }



    public synchronized boolean Lock ( int connId )
    {
        if( !pLocked )
        {
            pLocked = true;
            pChanged = false;
            pConnectionId = connId;
            return true;
        }

        if( pConnectionId == connId )
            return true;

        return false;
    }

    public synchronized boolean Unlock ( int connId )
    {
        if( pLocked && (pConnectionId==connId) )
        {
            pLocked = false;
//            pchanged = false;
            pConnectionId = 0;
            return( true );
        }
        return( false );
    }


    public synchronized void SetChanged ( int connId, boolean changed )
    {
        if( pLocked && (pConnectionId == connId) )
            pChanged = changed;
    }



}

