/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * package: COPSE
 * Classe: CObjectStreamConnector
\******************************************************************************/

package COPSE;

import java.io.*;
//import java.net.*;
import java.util.*;


public class CObjectStreamConnector
    implements CEventConnector
{
    // Streams to communicate
    private ObjectInputStream   pInput;
    private ObjectOutputStream  pOutput;

    public CObjectStreamConnector ( InputStream in, OutputStream out )
        throws IOException
    {
        pInput  = new ObjectInputStream( in );
        int i = pInput.readInt();
        pOutput = new ObjectOutputStream( out );
        pOutput.writeInt( i );
        pOutput.flush();
    }

    public CObjectStreamConnector ( OutputStream out, InputStream in )
        throws IOException
    {
        int i = 2345;
        pOutput = new ObjectOutputStream( out );
        pOutput.writeInt( i );
        pOutput.flush();

        pInput  = new ObjectInputStream( in );
        i = pInput.readInt();

        if( i != 2345 )
            throw new IOException( "[DEBUG] CObjectStreamConnector - invalid magic number..." );
    }

    public Object ReadObject()
        throws IOException
    {
        try {
            return pInput.readObject();
        } catch (ClassNotFoundException ce)
        {
            // DEBUG
            ce.printStackTrace( System.err );
            throw new IOException( "DEBUG: CObjectStreamConnector Class Not Found Exception" );
        }

    }

    public void WriteObject( Object obj )
        throws IOException
    {
        pOutput.writeObject( obj );
    }

    public CEvent Receive()
        throws IOException
    {
        Object obj = ReadObject();

        if( obj instanceof CEvent )
            return((CEvent) obj);

        throw new IOException( "Data error on communication with server" );
    }

    public void Send( CEvent event )
        throws IOException
    {
        WriteObject( event );
    }

    public void Flush()
    {
        try {
            pOutput.flush();
        } catch (Exception e) {};
    }

    public void Close()
    {
        try {
            pOutput.flush();
            pOutput.close();
            pInput.close();
        } catch (Exception e) {};
    }
}