/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: COPSE
 * Classe:  CProcessUsersSession
\******************************************************************************/

package COPSE;

import java.io.*;
import java.util.*;

public class CProcessUsersSession
    implements Serializable
{
    private Vector      pEntries;


    protected class _ProcessUserEntry
        implements Serializable
    {
        public int      Id;
        public Vector   Users;

        public _ProcessUserEntry()
        {
            Id = 0;
            Users = new Vector();
        }

        public void AddEntry( int userId )
        {
            Users.addElement( new Integer(userId) );
        }

        public void RemoveEntry( int userId )
        {
            Users.removeElement( new Integer(userId) );
        }

    }


    public CProcessUsersSession()
    {
        pEntries = new Vector();
    }

    private _ProcessUserEntry _FindEntry( int id )
    {
        Enumeration e = pEntries.elements();
        while( e.hasMoreElements() )
        {
            _ProcessUserEntry entry = (_ProcessUserEntry) e.nextElement();
            if( entry.Id == id )
                return entry;
        }
        return null;
    }

    public synchronized void AddEntry( int ActivId, int UserId )
    {
        _ProcessUserEntry entry = _FindEntry( ActivId );
        if( entry == null )
        {
            entry = new _ProcessUserEntry();
            entry.Id = ActivId;
            pEntries.addElement(entry);
        }

        entry.AddEntry( UserId );
    }

    public synchronized void RemoveEntry( int ActivId, int UserId )
    {
        _ProcessUserEntry entry = _FindEntry( ActivId );
        if( entry != null )
        {
            entry.RemoveEntry( UserId );
            if( entry.Users.size() == 0 )
                pEntries.removeElement( entry );
        }
    }


    public synchronized Enumeration GetUsersInActivity( int ActivityId )
    {
        _ProcessUserEntry entry = _FindEntry( ActivityId );
        if( entry != null )
            return entry.Users.elements();
        return (new Vector()).elements();
    }

}