/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: COPSE
 * Classe: CSocketStreamConnector
\******************************************************************************/

package COPSE;

import java.io.*;
import java.net.*;

public class CSocketStreamConnector
    extends CObjectStreamConnector
{
    Socket             pSocket;

    public static CSocketStreamConnector New ( Socket socket )
        throws IOException
    {
        return New( socket, true );
    }

    public static CSocketStreamConnector New ( Socket socket, boolean InOutOrder )
        throws IOException
    {
        CSocketStreamConnector pConn;


        if( InOutOrder )
        {
            InputStream  in  = socket.getInputStream();
            OutputStream out = socket.getOutputStream();
            pConn = new CSocketStreamConnector( socket, in, out );
        }
        else
        {
            OutputStream out = socket.getOutputStream();
            InputStream  in  = socket.getInputStream();
            pConn = new CSocketStreamConnector( socket, out, in );
        }

        return pConn;
    }



    private CSocketStreamConnector( Socket socket, InputStream in, OutputStream out )
        throws IOException
    {
        super( in, out );
        pSocket = socket;
    }

    private CSocketStreamConnector( Socket socket, OutputStream out, InputStream in )
        throws IOException
    {
        super( out, in );
        pSocket = socket;
    }



    public void Close()
    {
        try {
            pSocket.close();
        } catch( Exception e ) {};
    }
}

