/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: COPSE
 * Classe:  CTimer
\******************************************************************************/


package COPSE;

import java.util.*;

public class CTimer
    extends Thread
{
    protected Vector    pListeners;

    protected long      mMili;
    protected int       mNano;

    protected boolean   mExit;

    public CTimer( long mili, int nano )
    {
        super();
        mMili = mili;
        mNano = nano;

        pListeners = new Vector();
        mExit = false;
    }

    public CTimer ( long mili )
    {
        this( mili, 0 );
    }


    public void AddListener( CTimerListener listener )
    {
        pListeners.addElement( listener );
    }

    public void run()
    {
        while( !mExit )
        {
            try {
                sleep( mMili, mNano );
            } catch( Exception e ) {}

            Enumeration e = pListeners.elements();
            while( e.hasMoreElements() )
            {
                CTimerListener listener = (CTimerListener) e.nextElement();
                listener.OnTimerEvent( this );
            }
        }
    }

}