/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: COPSE
 * Classe:  CToolRegistry
\******************************************************************************/

package COPSE;

import java.io.*;
import java.util.*;

import FILE.*;

public class CToolRegistry
    extends CElement
{
    private     String      mName;
    private     String      mCommand;
    private     String      mDescription;

    private     Vector      pMetaProcIds;

//    private     Vector      pDocTypeIds;

    public CToolRegistry()
    {
        super();

        mName = "Tool";
        mCommand = "java Tool";
        mDescription = "";

        pMetaProcIds = new Vector();
    }


    public String   GetName()                       { return mName; }
    public void     SetName(String name)            { mName = name; }

    public String   GetDescription()                { return mDescription; }
    public void     SetDescription(String desc)     { mDescription = desc; }


    public String   GetCommand()                    { return mCommand; }
    public void     SetCommand(String comm)         { mCommand = comm; }



    public void AddMetaProcessId (int id)
    {
        pMetaProcIds.addElement(new Integer(id));
    }

    public void RemoveMetaProcessId (int id)
    {
        pMetaProcIds.removeElement(new Integer(id));
    }

    public Enumeration  GetMetaProcessIds()
    {
        return pMetaProcIds.elements();
    }


    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CToolRegistry");
        pStr.println( "       Name:          " + mName );
        pStr.println( "       Description:   " + mDescription );
        pStr.println( "       Command:       " + mCommand );

        super.DEBUG_write( pStr );
    }

}