/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * package: COPSE.SERVER
 * Classe: CServerAwarenessPointerHandler
\******************************************************************************/

package COPSE.SERVER;

import java.io.*;
import java.net.*;
import java.util.*;


import COPSE.*;
import COPSE.CONTROL.*;
import FILE.*;


public class CServerAwarenessPointerHandler
    extends  CServerCollaborationHandler
{
    // Mantains a list with each client that has turned on the multiple cursor pointer feature...
    protected Vector            pUserConnections;


    public CServerAwarenessPointerHandler( CServerCollaborationManager manager )
    {
        super( manager );
        pUserConnections = new Vector();
    }


    protected void ProcessEvent( CEvent event, CConnectionHandler handler )
    {
        CUserConnectionHandler userHandler = null;
        if( !(handler instanceof CUserConnectionHandler) )
            return;

        CServerToolSession toolSession = GetToolSession(handler);

        switch( event.GetType() )
        {
            case CEvent.EvCollaboration_Awareness_Pointer_On:
                {
                    if( pUserConnections.indexOf( handler ) == -1 )
                        pUserConnections.addElement( handler );
                    try {
                        userHandler.Send( event );
                    } catch (Exception exc)
                    {}
                }
                break;

            case CEvent.EvCollaboration_Awareness_Pointer_Off:
                {
                    if( pUserConnections.indexOf( handler ) != -1 )
                        pUserConnections.removeElement( handler );
                    try {
                        userHandler.Send( event );
                    } catch (Exception exc)
                    {}
                }
                break;

            case CEvent.EvCollaboration_Awareness_Pointer_Position:
                {
                    Enumeration e = pUserConnections.elements();
                    while( e.hasMoreElements() )
                    {
                        CUserConnectionHandler user = (CUserConnectionHandler) e.nextElement();
                        try {
                            user.Send( event );
                        } catch (Exception exc)
                        {
                            pUserConnections.removeElement( user );
                        }
                    }
                }
                break;

            default:
                super.ProcessEvent( event, handler );
        }
    }

    public void Exit()
    {
        pUserConnections = null;
        super.Exit();
    }

}

