/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * package: COPSE.SERVER
 * Classe: CServerAwarenessScreenHandler
\******************************************************************************/

package COPSE.SERVER;

import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.Rectangle;

import COPSE.*;
import COPSE.CONTROL.*;
import FILE.*;


public class CServerAwarenessScreenHandler
    extends  CServerCollaborationHandler
{
    // Mantains a list with each client that has turned on the Screen Awareness...
    protected Hashtable            pUserPositions;


    public CServerAwarenessScreenHandler( CServerCollaborationManager manager )
    {
        super( manager );
        pUserPositions = new Hashtable();
    }


    protected void ProcessEvent( CEvent event, CConnectionHandler handler )
    {
        CUserConnectionHandler userHandler;
        try{
            userHandler = (CUserConnectionHandler) handler;
        }catch( Exception exc) { return; }


        CServerToolSession toolSession = GetToolSession(handler);

        switch( event.GetType() )
        {
            /*
            case CEvent.EvCollaboration_Awareness_Screen_On:
                {
                    if( pUserConnections.indexOf( handler ) == -1 )
                        pUserConnections.addElement( handler );
                    userHandler.Notify( event );
                }
                break;

            case CEvent.EvCollaboration_Awareness_Screen_Off:
                {
                    if( pUserConnections.indexOf( handler ) != -1 )
                        pUserConnections.removeElement( handler );
                    userHandler.Notify( event );
                }
                break;
            */

            case CEvent.EvCollaboration_Awareness_Screen_Position:
                {
                    // Register the position of the user
                    Rectangle rect = (Rectangle) event.GetArgumentAt(1);
                    pUserPositions.put( handler, rect );

                    // Notify everyone in this tool
                    toolSession.NotifyAll( event );
                }
                break;


            case CEvent.EvCollaboration_Awareness_Screen_Load:
                {
                    Hashtable table = new Hashtable();
                    Enumeration keys    = pUserPositions.keys();
                    Enumeration e       = pUserPositions.elements();
                    while( e.hasMoreElements() && keys.hasMoreElements() )
                    {
                        CUserConnectionHandler user = (CUserConnectionHandler) keys.nextElement();
                        Rectangle rect = (Rectangle) e.nextElement();

                        if(! user.isAlive() )
                            pUserPositions.remove( user );
                        else
                            table.put( new Integer(user.GetUserSession().GetUserId()), rect );
                    }

                    event = new CEvent( CEvent.EvCollaboration_Awareness_Screen_Load );
                    event.AddArgument( table );
                    try {
                        userHandler.Send( event );
                    } catch (Exception exc) {};
                }
                break;

            default:
                super.ProcessEvent( event, handler );
        }
    }

    public void Exit()
    {
        pUserPositions = null;
        super.Exit();
    }
}

