/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: CServerManager
\******************************************************************************/

package COPSE.SERVER;

import java.io.*;
import java.util.*;

import COPSE.*;
import FILE.*;



public class CServerManager
    extends CServer
{
    protected   CLocator        pFileLocator;

    public CServerManager( int port, CLocator locator, CFile file )
        throws Exception
    {
        super( port, null );

        pFileLocator = locator;
        SetFile( file );
    }

    public      CLocator    GetLocator()        { return pFileLocator; }


    /** Init the Event Handler
     */
    protected void InitEventHandler()
        throws Exception
    {
        System.err.println( "[DEBUG] CServerManager - InitEventHandler:" );

        // Create the default event dispatcher
        super.InitEventHandler();

        // Create the ManagedServerEventHandler with the default eventHandler
        System.err.println( "[DEBUG] CServerManager - Creating ManagedServerEventHandler..." );
        pEventHandler = CreateManagerEventHandler();
        pEventHandler.start();
    }

    protected CServerManagerEventHandler CreateManagerEventHandler()
    {
        return new CServerManagerEventHandler( this, pEventHandler );
    }



    /**  Init the file management.
     *   By default, it doesn't do anything (the file will be set by the constructor)
     */
    protected void InitFileManagement( String fileName )
        //throws IOException
    {
        System.err.println( "[DEBUG] CServerManager - InitFileManagement:" );
    }


    public void Exit()
    {
        super.Exit();

        // close the ServerEventHandler
        // (the ManagerEventHandler has already been stopped by superclass...)
        ((CServerManagerEventHandler)pEventHandler).GetEventHandler().stop();
    }


    protected void CloseFile()
    {
        super.CloseFile();
    }



}

