/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * package: COPSE.SERVER
 * Classe:  CServerToolSession
\******************************************************************************/

package COPSE.SERVER;

//import java.io.*;
//import java.net.*;
import java.util.*;


import COPSE.*;
//import FILE.*;



public class CServerToolSession
    extends CToolSession
{
    public CServerToolSession( int toolId )
    {
        super( toolId );
    }

    public void NotifyAll( CEvent event )
    {
        Enumeration e = pUserSessions.elements();
        while( e.hasMoreElements() )
        {
            CServerUserSession session = (CServerUserSession) e.nextElement();
            session.Notify( event );
        }
    }

    public void NotifyAllExcept( CServerUserSession user, CEvent event )
    {
        Enumeration e = pUserSessions.elements();
        while( e.hasMoreElements() )
        {
            CServerUserSession session = (CServerUserSession) e.nextElement();
            if( user != session )
                session.Notify( event );
        }
    }

    public void NotifyUser( int userId, CEvent event )
    {
        CServerUserSession session = (CServerUserSession) FindUserSession(userId);
        if( session != null )
            session.Notify( event );
    }

    public synchronized CToolSession CloneAsToolSession()
    {
        CToolSession tool = new CToolSession( GetToolId() );

        Enumeration e = pUserSessions.elements();
        while( e.hasMoreElements() )
        {
            CServerUserSession session = (CServerUserSession) e.nextElement();
            tool.AddUserSession( session.CloneAsUserSession() );
        }

        return tool;
    }

}
