/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: FILE
 * Classe:  CDocEntry
\******************************************************************************/

package FILE;

import java.io.*;
import java.util.*;


public class CDocEntry
    extends CFSEntry
{
    protected int     mDocTypeId;

    //** Constructor
    public CDocEntry()
    {
        super();
        mDocTypeId = 0;
    }

    public CDocEntry( String name )
    {
        this();
        SetName( name );
    }


    public int  GetDocTypeId()          { return mDocTypeId; }
    public void SetDocTypeId(int id)    { mDocTypeId = id; }


    public CDocument Load( String productDir )
        throws IOException
    {
        String path = productDir + "/" + GetParentPath();
        CDocument doc;
        try{
            doc = (CDocument) CFile.Load( mName, path );
        } catch ( ClassNotFoundException ce )
        {   throw new IOException (""); }
        return doc;
    }


    public CDocument Create( String productDir )
        throws IOException
    {
        String path = productDir + "/" + GetParentPath();
        File file = new File( path );
        if( !file.exists() )
            file.mkdirs();

        CDocument doc = new CDocument( mName, path );
        doc.SetTypeId( mDocTypeId );
        doc.Save();
        return doc;
    }

    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CDocEntry");
        super.DEBUG_write(pStr);
    }

}
