/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: FILE
 * Classe:  CDocument
\******************************************************************************/

package FILE;

import java.io.*;
import java.util.*;

public class    CDocument
    extends     CFile
{
    protected Vector    pVersions;
    protected int       mTypeId;

    public CDocument()
    {
        super();
        pVersions = new Vector();
        mTypeId = 0;
    }

    public CDocument( String name, String path )
    {
        super( name, path );
        pVersions = new Vector();
        mTypeId = 0;
    }


    public int  GetTypeId ()        { return mTypeId; }
    public void SetTypeId (int id)  { mTypeId = id; }


    public CVersion CreateVersion()
    {
        CVersion version = new CVersion( this );
        AddElement( version );
        pVersions.addElement( version );
        return version;
    }

    public CVersion GetVersion( int vId )
    {
        CElement elem = GetElement( vId );
        if( elem instanceof CVersion )
            return (CVersion)  elem;
        return null;
    }

    public Enumeration GetVersions()
    {
        return pVersions.elements();
    }

    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CDocument");
        super.DEBUG_write( pStr );
    }



}