/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: FILE.OBJ
 * Classe:  CObjAttribute
\******************************************************************************/

package FILE.OBJ;

import  java.io.PrintStream;

import  FILE.*;

/*************************************************************************
 *  Class CObjAttribute
 *************************************************************************/
public class    CObjAttribute
    extends     CObjFeature
{
    // attributes
    protected   String      mInitialValue;

    // Constructor
    public CObjAttribute ()
    {
        super();
        mInitialValue = "";
    }

    public CObjAttribute (String name)
    {
        super(name);
        mInitialValue = "";
    }


    // Attributes
    public String   GetInitialValue ()              { return mInitialValue; }
    public void     SetInitialValue (String value)  { mInitialValue = value; }



    //* Clone
    public CElement Clone()
    {
        CObjAttribute attr = new CObjAttribute();
        attr.CopyFrom( this );
        return attr;
    }

    public void CopyFrom( CElement elem )
    {
        if( !(elem instanceof CObjAttribute) )
            return;

        super.CopyFrom( elem );

        CObjAttribute attr = (CObjAttribute) elem;
        SetInitialValue( attr.GetInitialValue() );
    }




    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "Attrib:  "+mName+": "+mType+" = "+mInitialValue );
    }
}
