/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: GRAPH
 * Classe:  CGrpGroup
\******************************************************************************/

package GRAPH;

import java.awt.*;
import java.util.*;


public class CGrpGroup
    extends CGrpObject
{
    protected   Vector      pObjects;
    
    public CGrpGroup()
    {
        super();
        pObjects = new Vector();
    }
    
    public void SetRegion( Rectangle rect )
    {
        // Resize the objects to be inside this new region
    }
    
    private void _AdjustRegion()
    {
        pRegion = new Rectangle();
        
        Enumeration e = pObjects.elements();
        while( e.hasMoreElements() )
        {
            CGrpObject object = (CGrpObject) e.nextElement();
            pRegion.union( object.getBounds() );
        }
    }
    
    public void AddObject( CGrpObject object )
    {   pObjects.addElement( object );
        _AdjustRegion();
    }
    
    public void RemoveObject( CGrpObject object )
    {   pObjects.removeElement( object );
        _AdjustRegion();
    }
    
    public Enumeration GetObjects()
    {   return pObjects.elements(); }
    
    
    public void Draw( CGraphics g )
    {
        
        Color oldColor = null;
        if( pColor != null )
        {
            oldColor = g.getColor();
            g.setColor( pColor );
        }

        if( IsDashed() ) g.SetDashedPen();
        
        
        Enumeration e = pObjects.elements();
        while( e.hasMoreElements() )
            ((CGrpObject)e.nextElement()).Draw( g );
    
        if( IsDashed() ) g.SetSolidPen();

        if( oldColor != null )
            g.setColor( oldColor );
    }
    
}