/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: GRAPH
 * Classe:  CGrpLine
\******************************************************************************/

package GRAPH;

//import java.io.*;
import java.awt.*;
//import java.util.*;


public class CGrpLine
    extends CGrpObject
{
    protected Point     pP1, pP2;
    protected Polygon   pPoly = null;

    public CGrpLine ( Point p1, Point p2 )
    {
        this( p1, p2, false );
    }

    public CGrpLine( Point p1, Point p2, boolean dashed )
    {
        super( dashed );
        pP1 = p1;
        pP2 = p2;
        _AdjustRegion();
    }

    private void _AdjustRegion()
    {
        SetRegion( new Rectangle( pP1.x, pP1.y, pP2.x-pP1.x, pP2.y-pP1.y ) );
    }

    public void SetPoint( int i, Point p )
    {
        if( i == 1 )
            pP1 = p;
        else
            pP2 = p;
        pPoly = null;
        _AdjustRegion();
    }




    public void Draw( CGraphics g )
    {
        Color oldColor = null;
        if( pColor != null )
        {
            oldColor = g.getColor();
            g.setColor( pColor );
        }

        if( IsDashed() ) g.SetDashedPen();
        g.drawLine( pP1.x, pP1.y, pP2.x, pP2.y );
        if( IsDashed() ) g.SetSolidPen();

        if( oldColor != null )
            g.setColor( oldColor );
    }


    public boolean Contains( Point p )
    {
        if( pPoly == null )
        {
            pPoly = new Polygon();
            pPoly.addPoint( pP1.x+5, pP1.y+5);
            pPoly.addPoint( pP1.x-5, pP1.y-5);
            pPoly.addPoint( pP2.x+5, pP2.y-5);
            pPoly.addPoint( pP2.x-5, pP2.y+5);

            //pPoly.addPoint( pP1.x+5, pP1.y+5);
        }
        return( pPoly.contains(p.x,p.y) );
    }

}