/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: GRAPH
 * Classe:  CGrpLozenge
\******************************************************************************/

package GRAPH;

import java.awt.*;
//import java.io.*;


public class    CGrpLozenge
    extends     CGrpObject
{
    protected   CPolyline       pPoly;

    public CGrpLozenge ( Rectangle rect )
    {
        super();
        SetRegion( rect );
    }

    public void SetRegion( Rectangle rect )
    {
        super.SetRegion( rect );
        _AdjustPolyline();
    }

    private void     _AdjustPolyline()
    {
        int dx = pRegion.width / 2;
        int dy = pRegion.height / 2;

        pPoly = new CPolyline();
        pPoly.AddPoint( new Point(pRegion.x, pRegion.y + dy) );
        pPoly.AddPoint( new Point(pRegion.x + dx, pRegion.y ) );
        pPoly.AddPoint( new Point(pRegion.x + pRegion.width, pRegion.y + dy ) );
        pPoly.AddPoint( new Point(pRegion.x + dx, pRegion.y + pRegion.height ) );
    }


    public void           Draw        (CGraphics g)
    {
        Color oldColor;

        if( IsFilled() )
        {
            oldColor = null;
            if( pFillColor != null )
            {
                oldColor = g.getColor();
                g.setColor( pFillColor );
            }
            g.fillPolygon( pPoly );

            if( oldColor != null )
                g.setColor( oldColor );
        }




        oldColor = null;
        if( pColor != null )
        {
            oldColor = g.getColor();
            g.setColor( pColor );
        }

        if( IsDashed() ) g.SetDashedPen();
        g.drawPolygon( pPoly );
        if( IsDashed() ) g.SetSolidPen();

        if( oldColor != null )
            g.setColor( oldColor );
    }

}