/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: GRAPH
 * Classe:  CScale
\******************************************************************************/

package GRAPH;

import java.io.*;
import java.awt.*;
import java.util.*;


public class CScale
    implements Serializable
{
    public double    xScale;
    public double    yScale;

    public CScale()
    {   xScale = yScale = 1.0; }

    public CScale( double x, double y )
    {
        xScale = x;
        yScale = y;
    }

    public  int     RTS_X( int x )
    {
        return (int)(xScale * x);
    }

    public  int     RTS_Y( int y )
    {
        return (int)(yScale * y);
    }

    public  Point       RTS_Point( Point p )
    {   return new Point( RTS_X(p.x), RTS_Y(p.y) ); }

    public  Rectangle   RTS_Rect( Rectangle r )
    {   return new Rectangle( RTS_X(r.x), RTS_Y(r.y), RTS_X(r.width), RTS_Y(r.height) ); }


    // STR: Scaled view to Real
    public   int     STR_X( int x )
    {   return (int)(x / xScale );  }

    public   int     STR_Y( int y )
    {   return (int)(y / yScale);  }

    public   Point         STR_Point( Point p )
    {   return new Point( STR_X(p.x), STR_Y(p.y) ); }

    public   Rectangle     STR_Rect( Rectangle r )
    {   return new Rectangle( STR_X(r.x), STR_Y(r.y), STR_X(r.width), STR_Y(r.height) ); }


}

