/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: PROCESS
 * Classe:  CAbstractProcess
\******************************************************************************/

package PROCESS;

import java.io.*;
import java.util.*;

import FILE.CFile;
import FILE.CElement;

import PROCESS.MODEL.*;

public abstract class    CAbstractProcess
    extends CModel
{

    protected boolean           mIsFixed;
    protected CAbstractActivity pTopActivity;

    public  CAbstractProcess()
    {
        super();
        pTopActivity = null;
        mIsFixed = false;
    }

    public  CAbstractProcess( String name, String path )
    {
        super(name, path);
        pTopActivity = null;
        mIsFixed = false;
    }



    // Setup activities
    public abstract void   SetupActivities();
    /*
    {
        CModelHeader mHeader = GetModelHeader();
        CSubModel subModel = mHeader.GetSubModel();

        pTopActivity = new CActivity();
        pTopActivity.SetProcess( this );
        pTopActivity.SetName( mHeader.GetName() );
        pTopActivity.SetSubActivities( subModel );
    }
    */

    public CAbstractActivity    GetTopActivity()
    {   return pTopActivity; }


    public boolean  IsFixed()       { return mIsFixed; }

    public void     AddActivity( CAbstractActivity act )
    {
        if( mIsFixed )
            return;
        AddElement( act );
    }


    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CAbstractProcess" );
        pStr.println( "       TopActivity:  " + pTopActivity.GetName() );
        super.DEBUG_write( pStr );
    }

}


