/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: PROCESS.MODEL
 * Classe:  CSubModel
\******************************************************************************/

package PROCESS.MODEL;

import java.io.*;
import java.util.*;


import FILE.*;


public class    CSubModel
    extends     CElement
{
    /**
     *  The 'Step' that owns this sub-model. If this is the whole model,
     *  than it assumes StepId equals 0 (null)
     */
    protected CStep     pStep;


    protected Vector    pModelElements;


    public      CSubModel()
    {
        super();
        pStep = null;
        pModelElements = new Vector();
    }


    public CStep    GetOwnerStep()              { return pStep; }
    public void     SetOwnerStep( CStep step )  { pStep = step; }


    // ModelElements
    public void     AddModelElement ( CModelElement me )
    {
        pModelElements.addElement( me );
        me.SetParent( this );
    }

    public void     RemoveModelElement ( CModelElement me )
    {
        me.SetParent(null);
        pModelElements.removeElement( me );
    }

    public Enumeration   GetModelElements()
    {
        return pModelElements.elements();
    }



    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CSubModel (extends FILE.CElement)" );
        pStr.println( "       ParentStep:      " + pStep );
        pStr.println( "       No Elements:     " + pModelElements.size() );

        super.DEBUG_write( pStr );
    }



}
