

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import sunw.admin.avm.base.*;


import FILE.*;
import PROCESS2.*;

public class TestaBrowser
    implements Observer
{

    public static void main( String args[] )
        throws Exception
    {
        CFile file = CFile.Load( "process.copse", "." );
        CProcess process = (CProcess)file.GetElement( 1 );

        new TestaBrowser( process );
    }


    //Browser         mBrowser;
    //BrowserFolder   mTopNode;
    Label           mMessageLabel;

    CProcess        pProcess;


    public TestaBrowser( CProcess proc )
    {
        pProcess = proc;


        Frame frame = new Frame( "Testa Browser - Processo" );

        mBrowser = new Browser();

        populateBrowser();

        mBrowser.addSelectionObserver(this);

        mBrowser.setLineColor         (Color.black);
        mBrowser.setTextColor         (Color.black);
        mBrowser.setViewportBackground(Color.lightGray);
        mBrowser.setViewportInsets    (new Insets(5,5,5,5));
        mBrowser.setFont              (new Font("Dialog", Font.ITALIC, 12));

        Panel p = new Panel();
        p.setLayout( new FlowLayout() );
        p.add( mMessageLabel = new Label( "Testing Browser and Process..." ) );




        frame.setLayout(new BorderLayout());

        frame.add("North", p );

        frame.add("Center", mBrowser);

        frame.setVisible( true );
    }


    public void update(Observable observable, Object what)
    {
        if(what instanceof BrowserNode )
        {
            BrowserNode node = (BrowserNode) what;
/*
            String s = node.getString();
            mMessageLabel.setLabel( s );
*/
            System.out.print(node.getString());

            if(node.isSelected()) System.out.println(" Selected");
            else                  System.out.println(" Deselected");
        }
    }



    private BrowserFolder populateBrowserWithActivity( CAbstractActivity act )
    {
        BrowserFolder   mainFolder, folder;
        BrowserItem     item;

        mainFolder = new BrowserFolder( mBrowser, act.GetName() );

        Enumeration e = act.GetActivities();
        while( e.hasMoreElements() )
        {
            CAbstractActivity elem = (CAbstractActivity)e.nextElement();
            if( elem.HasActivities() )
            {
                folder = populateBrowserWithActivity( elem );
                //folder.addObserver( this );
                mainFolder.append( folder );
            }
            else
            {
                item = new BrowserItem( mBrowser, elem.GetName() );
                mainFolder.append( item );
            }
        }

        mainFolder.expand();
        return mainFolder;
    }




    private void populateBrowser()
    {
        mTopNode = populateBrowserWithActivity( pProcess );
        mBrowser.setTopNode( mTopNode );
    }

}