/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: PRODUCT
 * Classe:  CBaseline
\******************************************************************************/

package PRODUCT;

import java.io.*;
import java.util.*;

import FILE.*;



public class CBaseline
    extends CElement
{
    protected String    mName;
    protected String    mDescription;

    protected Vector    pEntries;

    //** Constructor
    public CBaseline()
    {
        super();
        mName = "Baseline";
        mDescription = "";
        pEntries = new Vector();
    }

    public String   GetName ()                      { return mName; }
    public void     SetName (String name)           { mName = name; }

    public String   GetDescription ()               { return mDescription; }
    public void     SetDescription (String desc)    { mDescription = desc; }


    private CBaseEntry  FindEntry (int docId)
    {
        Enumeration en = pEntries.elements();
        while( en.hasMoreElements() )
        {
            CBaseEntry base = (CBaseEntry) en.nextElement();
            if( base.GetDocumentId() == docId )
                return base;
        }
        return null;
    }

    public void     AddEntry (int docId, int verId)
    {
        CBaseEntry base = FindEntry(docId);
        if( base == null )
            pEntries.addElement( new CBaseEntry(docId,verId) );
        else
            base.SetVersionId( verId );
    }

    public void     RemoveEntry (int docId)
    {
        CBaseEntry base = FindEntry(docId);
        if( base != null )
            pEntries.removeElement( base );
    }

    public Enumeration  GetEntries()     { return pEntries.elements(); }


    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CBaseline");
        super.DEBUG_write(pStr);
    }

}
