/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: TOOL.PROCESS.CLIENT
 * Classe:  COPEDlgActivityNew
 ******************************************************************************/

package TOOL.PROCESS.CLIENT;


import  java.awt.*;
import  java.awt.event.*;
//import  java.util.*;

import  COPSE.*;
import  COPSE.CLIENT.*;
import  COPSE.CLIENT.GUI.*;
import  PROCESS2.*;


/*************************************************************************
 *  Class COPEDlgActivityNew
 *************************************************************************/
public class    COPEDlgActivityNew
    extends     Dialog
    implements  ActionListener, WindowListener, TextListener
{
    protected   CGUIToolManager         pToolManager;
    protected   CAbstractActivity       pParent;

	protected   TextField       textName;
	protected   Button          btnOk;
	protected   Button          btnCancel;


	public COPEDlgActivityNew( CGUIToolManager tool, CAbstractActivity parent )
	{
	    super( tool.GetGUIManager().GetMainWindow(), false );
	    pToolManager = tool;
	    pParent = parent;

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();

		Insets insets = getInsets();

		setSize(insets.left + insets.right + 300,insets.top + insets.bottom + 117);
		setFont(new Font("Helvetica", Font.PLAIN, 12));

		Label label = new Label("Name:");
		label.setBounds(insets.left + 14,insets.top + 15,56,15);
		add(label);

		textName = new TextField();
		textName.setBounds(insets.left + 84,insets.top + 15,189,24);
		textName.addTextListener( this );
		add(textName);

		btnOk = new Button("Ok");
		btnOk.setBounds(insets.left + 84,insets.top + 53,87,26);
		btnOk.addActionListener( this );
		btnOk.setEnabled( false );
		add(btnOk);

		btnCancel = new Button("Cancel");
		btnCancel.setBounds(insets.left + 182,insets.top + 53,88,26);
		btnCancel.addActionListener( this );
		add(btnCancel);

		setTitle("New Activity");
		setResizable(false);
		//}}
	}

    public synchronized void setVisible( boolean visible )
    {
        if( visible )
        {
        	Rectangle bounds = getParent().getBounds();
        	Rectangle abounds = getBounds();

        	setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
        	     bounds.y + (bounds.height - abounds.height)/2);
        }

    	super.setVisible(visible);
    }


    public void textValueChanged( TextEvent e )
    {
        if( e.getSource() == textName )
        {
            btnOk.setEnabled( !textName.getName().equals("") );
        }
    }


    // WindowEvent Listener methods
    public void windowOpened(WindowEvent e)         {}
    public void windowClosed(WindowEvent e)         {}
    public void windowClosing(WindowEvent e)        { _Close(false); }
    public void windowIconified(WindowEvent e)      { _Close(false); }
    public void windowDeiconified(WindowEvent e)    {}
    public void windowActivated(WindowEvent e)      {}
    public void windowDeactivated(WindowEvent e)    {}

    // ActionEvent Listener method
    public void actionPerformed( ActionEvent event )
    {
        Object source = event.getSource();

        if( source == btnCancel )
            _Close( false );
        else
        if( source == btnOk )
            _Close( true );

    }

    private void _Close( boolean ok )
    {
        if( ok )
        {
            try {
                CActivity act = new CActivity();
                act.SetName( textName.getText() );

                CEvent event = new CEvent( CEvent.EvCOPSE_FileController_Element_New );
                event.AddArgument( new Integer(pToolManager.GetClient().GetSessionManager().GetClientSession().GetConnectionId()) );
                event.AddArgument( act );
                event.AddArgument( new Integer(pParent.GetId()) );
                pToolManager.GetClient().Send( event );
            } catch( Exception e ) {}
        }

        setVisible( false );
        dispose();
    }


}