/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: TOOL.PROCESS.CLIENT
 * Classe:  ProcessControlPanel
\******************************************************************************/

package TOOL.PROCESS.CLIENT;


import  java.awt.*;
import  java.util.*;

//import  sunw.admin.avm.base.*;
import  com.sun.java.swing.*;
import  com.sun.java.swing.event.*;


import  PROCESS2.*;

import  COPSE.CLIENT.*;
import  COPSE.CONTROL.*;


import  TOOL.PROCESS.*;

public class ProcessControlPanel
    extends Panel
    //implements Observer
{
    protected   ProcessGUIManager       pGUI;
    protected   ProcessGUIToolManager   pToolManager;

    protected   CProcessFileController  pFileController = null;
    protected   CProcess                pProcess = null;

    // Selected Element
    protected   CAbstractActivity       pSelectedElement;

    // GUI Elements
    //protected   Browser                 mBrowser;
    //protected   BrowserFolder           mTopNode;
    protected   JTreeModel              pProcessModel;
    protected   TreeNode                pProcessRoot;


    protected   TextArea                mInformation;

    public      ProcessControlPanel ( ProcessGUIToolManager tool )
    {
        super();
        pToolManager = tool;
        pGUI = (ProcessGUIManager)pToolManager.GetGUIManager();

        pSelectedElement = null;

        createGUIElements();

        //addListener( this );
    }



    protected   void  createGUIElements()
    {
        GridBagLayout layout = new GridBagLayout();
        setLayout( layout );

        /*** BROWSER ***
        mBrowser = new Browser();
        mTopNode = new BrowserFolder( mBrowser, "Process" );
        mBrowser.setTopNode( mTopNode );
        mBrowser.addSelectionObserver(this);

        mBrowser.setLineColor         (Color.black);
        mBrowser.setTextColor         (Color.black);
        mBrowser.setViewportBackground(Color.lightGray);
        mBrowser.setViewportInsets    (new Insets(5,5,5,5));
        mBrowser.setFont              (new Font("Dialog", Font.ITALIC, 12));

        ScrollPane scrollPane = new ScrollPane();
        scrollPane.add( mBrowser );
        /**/

        pProcessRoot = new TreeNode( "Process" );
        //pProcessRoot.insert( new TreeNode( "Activity 1" ), 0 );
        //pProcessRoot.insert( new TreeNode( "Activity 2" ), 1 );
        //pProcessRoot.insert( new TreeNode( "Activity 3" ), 2 );

        pProcessModel    = new JTreeModel( pProcessRoot );

        JTree       processTree         = new JTree( pProcessModel );
        //processTree.

        JScrollPane scrollPane = new JScrollPane();
        scrollPane.getViewport().add( processTree );




        GridBagConstraints constraints = new GridBagConstraints();
		constraints.gridx = 0;
		constraints.gridy = 0;
		constraints.gridwidth = 1;
		constraints.gridheight = 3;
		constraints.weightx = 100;
		constraints.weighty = 300;
		constraints.fill = GridBagConstraints.BOTH;
		constraints.insets = new Insets(10,10,10,10);

		layout.setConstraints(scrollPane, constraints);
        add(scrollPane);


        // *** INFO PANEL ***
        Panel activityPanel = new Panel();
        activityPanel.setLayout( new BorderLayout() ); // CardLayout ???


        Panel centerPanel = new Panel();
        centerPanel.setLayout( new BorderLayout() );

        centerPanel.add( "North", new Label("Information:") );

        mInformation = new TextArea();
        mInformation.setEditable( false );
        centerPanel.add( "Center", mInformation );

        activityPanel.add( "Center", centerPanel );




        Panel southPanel = new Panel();
        southPanel.setLayout( new FlowLayout(FlowLayout.CENTER) );

        Label lockedMessageLabel = new Label("Label in the south of Activity Panel - Not locked");
        southPanel.add( lockedMessageLabel );
        southPanel.add( new Button("  Lock  ") );
        southPanel.add( new Button(" Unlock ") );

        activityPanel.add( "South", southPanel );

        //constraints = new GridBagConstraints();
		constraints.gridx = 1;
		constraints.gridy = 0;
		constraints.gridwidth = 3;
		constraints.gridheight = 3;
		constraints.weightx = 100;
		constraints.weighty = 300;
		constraints.fill = GridBagConstraints.BOTH;
		constraints.insets = new Insets(0,0,10,10);
		layout.setConstraints(activityPanel, constraints);
		add(activityPanel);


        //pack();
        //
    }

/*
    public void update(Observable observable, Object what)
    {
        if(what instanceof BrowserNode )
        {
            BrowserNode node = (BrowserNode) what;

            System.out.print(node.getString());
            if(node.isSelected()) System.out.println(" Selected");
            else                  System.out.println(" Deselected");
        }
    }

*/



    public void SetFileController( CFileController fileController )
    {
        pFileController = (CProcessFileController) fileController;
        if( pFileController != null )
        {
            //pUMLGraphModel = new CUMLGraphModel( pFileController );
            pProcess = (CProcess) pFileController.GetFile().GetElement( 1 );

            /*
            mTopNode = new BrowserFolder( mBrowser, pProcess );
            mBrowser.setTopNode( mTopNode );

            // Add to browser...
            populateFolderWithActivity(mTopNode, pProcess);
            */

            populateTree( pProcessRoot, pProcess );
        }
        else
        {
            /*
            // Remove from Browser...
            mTopNode = new BrowserFolder( mBrowser, "Process" );
            mBrowser.setTopNode( mTopNode );
            */

            pProcessRoot = new TreeNode( "Process" );
            pProcessModel.setRoot( pProcessRoot );


            /*
            pUMLGraphModel = null;
            pClassSelector = null;
            pRelationSelector = null;

            mNewClass = false;
            pNewClassRect = null;
            mNewRelation = false;
            pNewRelationLine = null;
            */
        }

        repaint();
    }






/*
    private void populateFolderWithActivity( BrowserFolder mainFolder, CAbstractActivity act )
    {
        BrowserFolder   //mainFolder,
                        folder;
        BrowserItem     item;

        //mainFolder = new BrowserFolder( mBrowser, act.GetName() );

        Enumeration e = act.GetActivities();
        while( e.hasMoreElements() )
        {
            CAbstractActivity elem = (CAbstractActivity)e.nextElement();
            if( elem.HasActivities() )
            {
                folder = new BrowserFolder( mBrowser, elem.GetName() );
                populateFolderWithActivity( folder, elem );
                mainFolder.append( folder );
            }
            else
            {
                if( elem.IsDefinedByTool() )
                {
                    item = new BrowserItem( mBrowser, elem.GetName() );
                    mainFolder.append( item );
                }
                else
                {
                    folder = new BrowserFolder( mBrowser, elem.GetName() );
                    populateFolderWithActivity( folder, elem );
                    mainFolder.append( folder );
                }
            }
        }

        mainFolder.expand();
        //return mainFolder;
    }
*/


    private void populateTree( TreeNode mainFolder, CAbstractActivity act )
    {
        TreeNode    node;
        int i = 0;

        //mainFolder = new TreeNode( mBrowser, act.GetName() );

        Enumeration e = act.GetActivities();
        while( e.hasMoreElements() )
        {
            CAbstractActivity elem = (CAbstractActivity)e.nextElement();
            if( elem.HasActivities() )
            {
                node = new TreeNode( elem.GetName() );
                populateTree( node, elem );
                mainFolder.insert( node, i );
            }
            else
            {
                node = new TreeNode( elem.GetName() );
                //populateTree( node, elem );
                mainFolder.insert( node, i );

                /*
                if( elem.IsDefinedByTool() )
                {
                    item = new BrowserItem( mBrowser, elem.GetName() );
                    mainFolder.append( item );
                }
                else
                {
                    folder = new BrowserFolder( mBrowser, elem.GetName() );
                    populateFolderWithActivity( folder, elem );
                    mainFolder.append( folder );
                }
                */
            }
            i++;
        }

        //mainFolder.expand();
        //return mainFolder;
    }

}