/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * package: TOOL.UML.CLIENT
 * Classe: UMLClientEventHandler
\******************************************************************************/

package TOOL.UML.CLIENT;


import  java.awt.Rectangle;

import  COPSE.*;
import  COPSE.CONTROL.*;
import  COPSE.CLIENT.*;
import  FILE.*;
import  FILE.OBJ.*;
import  GRAPH.CPolyline;
import  GRAPH.CSidePosition;
import  TOOL.UML.CUMLFileController;



/* ****************************************************************************
 * class UMLClientEventHandler
 ******************************************************************************/
public class    UMLClientEventHandler
    extends     CClientEventHandler
{
    CVisualFileController       pFileController = null;

    public UMLClientEventHandler( CClient client )
    {
        super(client);
    }

    protected   void FileControllerChanged( CClientFileControllerListener listener, int elemId, CEvent event )
    {
        /*
        switch( type )
        {
            case CEvent.EvCOPSE_FileController_Element_Visual:
                listener.ElementVisualChanged( elemId );
                break;

            default:
                super.FileControllerChanged( listener, elemId, type );
        }
        */
        super.FileControllerChanged( listener, elemId, event );
    }


    protected void ProcessEvent( CEvent event )
    {
        int type = event.GetType();

        if( pFileController == null )
            pFileController = (CVisualFileController) pClient.GetFileController();

        switch( type )
        {
            case CEvent.EvCOPSE_FileController_Element_Visual:
                {
                    //System.err.println( "[DEBUG] UMLClientEventHandler - ElementVisual changed!" );
                    int elemId = ((Integer)event.GetArgumentAt(0)).intValue();
                    int visual = ((Integer)event.GetArgumentAt(1)).intValue();

                    pFileController.SetElementVisual( elemId, visual );

                    NotifyFileControllerListeners( elemId, event );
                }
                break;

            case CEvent.EvUMLEditor_Class_Position:
                {
                    int classId = ((Integer) event.GetArgumentAt(0)).intValue();
                    Rectangle r = (Rectangle) event.GetArgumentAt(1);

                    CElement elem = pFileController.GetFile().GetElement( classId );
                    if( elem instanceof CObjClass )
                    {
                        CObjClass aclass = (CObjClass) elem;
                        aclass.SetRegion( r );
                        NotifyFileControllerListeners( classId, event );
                    }
                }
                break;


            /* */
            case CEvent.EvUMLEditor_Relation_Position:
                {
                    int relationId = ((Integer) event.GetArgumentAt(0)).intValue();
                    CSidePosition ext0 = (CSidePosition) event.GetArgumentAt(1);
                    CSidePosition ext1 = (CSidePosition) event.GetArgumentAt(2);
                    CPolyline poly = (CPolyline) event.GetArgumentAt(3);

                    CElement elem = pFileController.GetFile().GetElement( relationId );
                    if( elem instanceof CObjRelation )
                    {
                        CObjRelation relation = (CObjRelation) elem;

                        relation.GetExtremity(0).SetSidePosition( ext0 );
                        relation.GetExtremity(1).SetSidePosition( ext1 );
                        relation.SetInternalPoints( poly.GetPoints() );

                        NotifyFileControllerListeners( relationId, event );
                    }
                }
                break;

            /* */



            case CEvent.EvCOPSE_FileController_Element_New:
                {
                    CElement elem = (CElement) event.GetArgumentAt(1);
                    if( elem instanceof CObjRelation )
                    {
                        CObjRelation rel = (CObjRelation) elem;

                        Integer i0, i1;
                        i0 = (Integer) event.GetArgumentAt( 2 );
                        i1 = (Integer) event.GetArgumentAt( 3 );


                        CObjClass c0, c1;
                        //try {
                            c0 = (CObjClass) pFileController.GetFile().GetElement( i0.intValue() );
                            c1 = (CObjClass) pFileController.GetFile().GetElement( i1.intValue() );
                        //} catch ( Exception e ) { return; }


                        // Before adding the relation, stablish the links to classes...

                        CSidePosition s0, s1;
                        s0 = (CSidePosition) event.GetArgumentAt( 4 );
                        s1 = (CSidePosition) event.GetArgumentAt( 5 );

                        // Creating Extremities
                        CObjRelationExtremity extr = new CObjRelationExtremity( rel, c0 );
                        extr.SetSidePosition( s0 );

                        extr = new CObjRelationExtremity( rel, c1 );
                        extr.SetSidePosition( s1 );

                        // Now it's ok to add relation...
                        //super.ProcessEvent( event );
                        //return;

                    } // if newElement instanceof CObjRelation
                }
                break;



        }

        super.ProcessEvent( event );
    }
}