/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: TOOL.UML.CLIENT
 * Classe:  UMLDlgClass
 ******************************************************************************/

package TOOL.UML.CLIENT;


import  java.awt.*;
import  java.awt.event.*;
import  java.util.*;

import  COPSE.CLIENT.GUI.*;
import  FILE.OBJ.*;

/* ****************************************** BW *************************************** */
import	BW.*;
import	BW.kernel.*;
import  COPSE.CEvent;
/* ****************************************** BW *************************************** */


/*************************************************************************
 *  Class UMLDlgClass
 *************************************************************************/
public class    UMLDlgClass
    extends     Dialog
    implements  ActionListener, WindowListener
{
    protected CGUIManager           pGUI;
    protected UMLClassControl       pControl;


    protected CObjClass             pOldClass = null;
    protected CObjClass             pNewClass = null;
    protected boolean               mChanged = false;

    protected UMLDlgFeature         pDlgFeature = null;
    protected boolean               mFeatureEdit = false;
    protected boolean               mFeatureNew = false;
/*
    protected OBJClasse oldClass = null;
    protected OBJClasse newClass = null;

    protected OBJClasse p_classe = null;


    protected int estado = 0;
    protected final static int NOVO_ATRIB = 1;
    protected final static int EDIT_ATRIB = 2;
    protected final static int NOVO_METODO = 3;
    protected final static int EDIT_METODO = 4;
*/


	TextField      textName;
	TextField      textSter;
	TextField      textParam;

	Checkbox       checkAbstract;
	Button         btnOK;
	Button         btnCancel;

	List           listAttribs;
	Button         btnAttribNew;
	Button         btnAttribEdit;
	Button         btnAttribRemove;

	List           listMethods;
	Button         btnMethodNew;
	Button         btnMethodEdit;
	Button         btnMethodRemove;


/* ****************************************** BW *************************************** */
	Vector         BWChanges = null;
	String         BWClassName = "";
/* ****************************************** BW *************************************** */

	public UMLDlgClass(CGUIManager gui, boolean modal, UMLClassControl control)
	{
	    super(gui.GetMainWindow(), modal);
	    pGUI = gui;
	    pControl = control;

	    pOldClass = pControl.GetSelectedClass();
	    //try{
    	    pNewClass = (CObjClass)pOldClass.CloneWithoutRelations();
    	//} catch( CloneNotSupportedException e ) {}
        mChanged = false;

        addWindowListener( this );


		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();

		Insets insets = getInsets();
		setSize(insets.left + insets.right + 402,insets.top + insets.bottom + 445);
		setFont(new Font("Helvetica", Font.PLAIN, 12));
		//setFont(new Font("Helvetica", Font.PLAIN, 10));

		Label label;

		label = new Label("Class Name:");
		label.setBounds(insets.left + 14,insets.top + 15,91,15);
		add(label);

		textName = new TextField();
		//textName.setBounds(insets.left + 112,insets.top + 15,168,22);
		textName.setBounds(insets.left + 112,insets.top + 15,168,31);
		add(textName);

		checkAbstract = new Checkbox("Abstract");
		checkAbstract.setBounds(insets.left + 294,insets.top + 15,77,18);
		add(checkAbstract);

		label = new Label("Attributes:");
		label.setBounds(insets.left + 14,insets.top + 113,70,15);
		add(label);

		listAttribs = new List(0,false);
		listAttribs.setBounds(insets.left + 14,insets.top + 135,266,90);
		add(listAttribs);

		btnAttribNew = new Button("New...");
		btnAttribNew.setBounds(insets.left + 294,insets.top + 135,84,23);
		btnAttribNew.addActionListener( this );
		add(btnAttribNew);

		btnAttribEdit = new Button("Edit...");
		btnAttribEdit.setBounds(insets.left + 294,insets.top + 165,84,23);
		btnAttribEdit.addActionListener( this );
		add(btnAttribEdit);

		btnAttribRemove = new Button("Remove");
		btnAttribRemove.setBounds(insets.left + 294,insets.top + 195,84,23);
		btnAttribRemove.addActionListener( this );
		add(btnAttribRemove);

		btnOK = new Button("Ok");
		btnOK.setBounds(insets.left + 196,insets.top + 375,84,23);
		btnOK.addActionListener( this );
		add(btnOK);

		btnCancel = new Button("Cancel");
		btnCancel.setBounds(insets.left + 294,insets.top + 375,84,23);
		btnCancel.addActionListener( this );
		add(btnCancel);

		label = new Label("Methods:");
		label.setBounds(insets.left + 14,insets.top + 240,84,15);
		add(label);

		listMethods = new List(0,false);
		listMethods.setBounds(insets.left + 14,insets.top + 263,266,90);
		add(listMethods);

		btnMethodNew = new Button("New...");
		btnMethodNew.setBounds(insets.left + 294,insets.top + 263,84,23);
		btnMethodNew.addActionListener( this );
		add(btnMethodNew);

		btnMethodEdit = new Button("Edit...");
		btnMethodEdit.setBounds(insets.left + 294,insets.top + 293,84,23);
		btnMethodEdit.addActionListener( this );
		add(btnMethodEdit);

		btnMethodRemove = new Button("Remove");
		btnMethodRemove.setBounds(insets.left + 294,insets.top + 323,84,23);
		btnMethodRemove.addActionListener( this );
		add(btnMethodRemove);

		label = new Label("Stereotype:");
		label.setBounds(insets.left + 14,insets.top + 45,70,15);
		add(label);

		textSter = new TextField();
		//textSter.setBounds(insets.left + 112,insets.top + 45,168,23);
		textSter.setBounds(insets.left + 112,insets.top + 45,168,31);
		add(textSter);

		label = new Label("Parameters:");
		label.setBounds(insets.left + 14,insets.top + 75,70,15);
		add(label);

		textParam = new TextField();
		//textParam.setBounds(insets.left + 112,insets.top + 75,168,22);
		textParam.setBounds(insets.left + 112,insets.top + 75,168,31);
		add(textParam);


		setTitle("Class Edit");
		setResizable(false);
		//}}
	}


    public synchronized void setVisible( boolean visible )
    {
        if( visible )
        {
        	Rectangle bounds = getParent().getBounds();
        	Rectangle abounds = getBounds();

        	setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
        	     bounds.y + (bounds.height - abounds.height)/2);

                DataToView();
/* ****************************************** BW *************************************** */
		GW_BW_Mediator.BeginEvent (CEvent.EvCOPSE_FileController_Element_Update);		
		BWChanges = new Vector();
		BWClassName = new String();
/* ****************************************** BW *************************************** */
        }

    	super.setVisible( visible );
    }


    // WindowEvent Listener methods
    public void windowOpened(WindowEvent e)         {}
    public void windowClosed(WindowEvent e)         {}
    public void windowClosing(WindowEvent e)        { _Close(false); }
    public void windowIconified(WindowEvent e)      { _Close(false); }
    public void windowDeiconified(WindowEvent e)    {}
    public void windowActivated(WindowEvent e)      {}
    public void windowDeactivated(WindowEvent e)    {}

    // ActionEvent Listener method
    public void actionPerformed( ActionEvent event )
    {
        Object source = event.getSource();

        if( source == btnCancel )
            _Close( false );
        else
        if( source == btnOK )
            _Close( true );

        else
        if( source == btnAttribNew )
        {   _NewFeature( true );    }
        else
        if( source == btnAttribEdit )
        {   _EditFeature( true );   }
        else
        if( source == btnAttribRemove )
        {   _RemoveFeature( true ); }

        else
        if( source == btnMethodNew )
        {   _NewFeature( false );   }
        else
        if( source == btnMethodEdit )
        {   _EditFeature( false );  }
        else
        if( source == btnMethodRemove )
        {   _RemoveFeature( false );    }
    }

    private void _NewFeature( boolean isAttribute )
    {
        if( mFeatureEdit || mFeatureNew )
            return;

        CObjFeature feature;
        if( isAttribute )
        {
            CObjAttribute a = new CObjAttribute();
            a.SetName( "New attribute" );
            a.SetType( "Integer" );
            a.SetInitialValue( "0" );
            feature = a;
        }
        else
        {
            CObjMethod a = new CObjMethod();
            a.SetName( "New method" );
            a.SetType( "Integer" );
            a.SetParameters( "()" );
            feature = a;
        }

        mFeatureNew = true;
        pDlgFeature = new UMLDlgFeature( pGUI.GetMainWindow(), this );
        pDlgFeature.SetFeature( feature );
        pDlgFeature.setTitle( isAttribute ? "Attribute" : "Method" );
        pDlgFeature.setVisible( true );
    }

    private void _EditFeature( boolean isAttribute )
    {
        if( mFeatureEdit || mFeatureNew )
            return;

        CObjFeature feature;

        if( isAttribute )
        {
    	    int index = listAttribs.getSelectedIndex();
    	    if( index < 0 ) return;
            feature = pNewClass.FindAttribute( listAttribs.getItem(index) );
        }
        else
        {
    	    int index = listMethods.getSelectedIndex();
    	    if( index < 0 ) return;
            feature = pNewClass.FindMethod( listMethods.getItem(index) );
        }

        if( feature == null )   return;

        mFeatureEdit = true;
        pDlgFeature = new UMLDlgFeature( pGUI.GetMainWindow(), this );
        pDlgFeature.SetFeature( feature );
        pDlgFeature.setVisible( true );

    }


    private void _RemoveFeature( boolean isAttribute )
    {
        if( mFeatureEdit || mFeatureNew )
            return;

        if( isAttribute )
        {
    	    int index = listAttribs.getSelectedIndex();
    	    if( index < 0 ) return;
            CObjAttribute attr = pNewClass.FindAttribute( listAttribs.getItem(index) );
            if( attr != null )
            {
                pNewClass.RemoveAttribute( attr );
                _UpdateListAttributes();
                mChanged = true;
            }
        }
        else
        {
    	    int index = listMethods.getSelectedIndex();
    	    if( index < 0 ) return;
            CObjMethod method = pNewClass.FindMethod( listMethods.getItem(index) );
            if( method != null )
            {
                pNewClass.RemoveMethod( method );
                _UpdateListMethods();
                mChanged = true;
            }
        }

/* ****************************************** BW *************************************** */
	BWChanges.addElement (( isAttribute ? " Atributo " : " Metodo ")+" removido \n");
/* ****************************************** BW *************************************** */

    }


    public boolean      HasChanged()    { return mChanged; }

    public CObjClass    GetNewClass()   { return pNewClass; }

    public void DataToView()
    {
        textName.setText( pNewClass.GetName() );
        textSter.setText( pNewClass.GetStereotype() );
        textParam.setText( pNewClass.GetParameters() );
        checkAbstract.setState( pNewClass.IsAbstract() );

        _UpdateListAttributes();
        _UpdateListMethods();
    }

    private void _UpdateListAttributes()
    {
        Enumeration e;
        listAttribs.removeAll();
        e = pNewClass.GetAttributes();
        while( e.hasMoreElements() )
        {
            CObjAttribute attr = (CObjAttribute) e.nextElement();
            listAttribs.addItem( attr.GetName() );
        }
    }

    private void _UpdateListMethods()
    {
        Enumeration e;
        listMethods.removeAll();
        e = pNewClass.GetMethods();
        while( e.hasMoreElements() )
        {
            CObjMethod meth = (CObjMethod) e.nextElement();
            listMethods.addItem( meth.GetName() );
        }
    }

    public void ViewToData()
    {
        String text;

        text = textName.getText();
        if( !text.equals( pNewClass.GetName() ) )
        {   pNewClass.SetName( text );  mChanged = true; }

        text = textSter.getText();
        if( !text.equals( pNewClass.GetStereotype() ) )
        {   pNewClass.SetStereotype( text );  mChanged = true; }

        text = textParam.getText();
        if( !text.equals( pNewClass.GetParameters() ) )
        {   pNewClass.SetParameters( text );  mChanged = true; }

        boolean abstr = checkAbstract.getState();
        if( abstr != pNewClass.IsAbstract() )
        {   pNewClass.SetAbstract( abstr ); mChanged = true; }

/* ****************************************** BW *************************************** */
	BWClassName = new String (textName.getText());
/* ****************************************** BW *************************************** */

    }

    public void CloseDlgFeature( boolean ok )
    {
        if( pDlgFeature == null )
            return;

        if( ok )
        {
            mChanged = true;

            CObjFeature feature = pDlgFeature.GetFeature();

            if( mFeatureNew )
            {   // then adding new feature...
                if( feature instanceof CObjAttribute )
                {
                    if( pNewClass.AddAttribute( (CObjAttribute) feature ) )
                        listAttribs.addItem( feature.GetName() );
                }
                else
                if( feature instanceof CObjMethod )
                {
                    if( pNewClass.AddMethod( (CObjMethod) feature ) )
                        listMethods.addItem( feature.GetName() );
                }
            }
            else
            if( mFeatureEdit )
            {
                if( feature instanceof CObjAttribute )
                    _UpdateListAttributes();
                else
                if( feature instanceof CObjMethod )
                    _UpdateListMethods();
            }


/* ****************************************** BW *************************************** */
	   String BWsChanges = ( feature instanceof CObjAttribute ) ?  " Atributo " : " Metodo ";
	   BWsChanges +=       (mFeatureNew) ? " adicionado " : " ";
	   BWsChanges +=       (mFeatureEdit)? " editado " : " ";
	   BWsChanges +=       "\n";
	   BWChanges.addElement (BWsChanges);
/* ****************************************** BW *************************************** */

        }

        pDlgFeature.setVisible( false );
        pDlgFeature.dispose();
        pDlgFeature = null;
        mFeatureNew  = false;
        mFeatureEdit = false;
    }

    protected void _Close( boolean ok )
    {
        // For while...
        if( pDlgFeature != null )
        {   CloseDlgFeature(false); }

        if( ok ) {
            ViewToData();
/* ****************************************** BW *************************************** */
	    BW_Event BWEvent = new BW_Event (CEvent.EvCOPSE_FileController_Element_Update, typeIdDefault.UNSET);
	    try {
	    	BWEvent.setDescription ("Class Edited - "+BWClassName);
	   	String BWsChanges = "Classe "+BWClassName+" alterada:\n ";
	   	for (int BWi=0; BWi<BWChanges.size();BWi++)
	    		BWsChanges += (String) BWChanges.elementAt(BWi);
	    	BWEvent.setDetails (BWsChanges);	
	   } catch (NullPointerException npe) {
	   }
	   GW_BW_Mediator.EndEvent (CEvent.EvCOPSE_FileController_Element_Update,BWEvent);
/* ****************************************** BW *************************************** */
        }
/* ****************************************** BW *************************************** */
	   else {
		GW_BW_Mediator.CancelEvent (CEvent.EvCOPSE_FileController_Element_Update);
	   }
/* ****************************************** BW *************************************** */
        pControl.CloseDlgEdit(ok);
    }

/*
	public DlgClasse(Frame parent, String title, boolean modal)
	{
	    this(parent, modal);
	    setTitle(title);
	}




/*
    public synchronized void show()
    {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }




	void btnOK_Clicked(Event event)
	{
	    Container pai = getParent();

	    ViewToData();
	    p_classe = newClass;
	    pai.handleEvent( new Event(pai, MainFrame.EVENTO_DLG_OK, this) );
	    hide();
	}

	void btnCancel_Clicked(Event event)
	{
	    Container pai = getParent();
	    pai.handleEvent( new Event(pai, MainFrame.EVENTO_DLG_CANCEL, this) );
	    hide();
	}


	void btnAtribNew_Clicked(Event event)
	{
	    OBJAtributo atr = new OBJAtributo( "New Attribute" );
		DlgAttribute dlg = new DlgAttribute( (Frame)getParent(), this, "New Attribute", true );
		dlg.SetCaracteristica( atr );
		dlg.show();

		estado = NOVO_ATRIB;
	}

	void btnAtribEdit_Clicked(Event event)
	{
	    int index = listAttrib.getSelectedIndex();
	    if( index < 0 ) return;

	    OBJAtributo atr = newClass.FindAtributo( listAttrib.getItem(index) );
	    if( atr == null ) return;

		DlgAttribute dlg = new DlgAttribute( (Frame)getParent(), this, "Edit Attribute", true );
		dlg.SetCaracteristica( atr );
		dlg.show();

		estado = EDIT_ATRIB;
	}

	void btnAtribRemove_Clicked(Event event)
	{
        int index = listAttrib.getSelectedIndex();
	    if( index < 0 ) return;

	    OBJAtributo atr = newClass.FindAtributo( listAttrib.getItem(index) );
	    if( atr == null ) return;

	    newClass.RemoveAtributo( atr );
	    listAttrib.delItem( index );
	}


	void btnMethodNew_Clicked(Event event)
	{
	    OBJMetodo met = new OBJMetodo( "New Method" );
		DlgAttribute dlg = new DlgAttribute( (Frame)getParent(), this, "New Method", true );
		dlg.SetCaracteristica( met );
		dlg.show();

		estado = NOVO_METODO;
	}

	void btnMethodEdit_Clicked(Event event)
	{
	    int index = listMethods.getSelectedIndex();
	    if( index < 0 ) return;

	    OBJMetodo met = newClass.FindMetodo( listMethods.getItem(index) );
	    if( met == null ) return;

		DlgAttribute dlg = new DlgAttribute( (Frame)getParent(), this, "Edit Method", true );
		dlg.SetCaracteristica( met );
		dlg.show();

		estado = EDIT_METODO;
	}

	void btnMethodRemove_Clicked(Event event)
	{
        int index = listMethods.getSelectedIndex();
	    if( index < 0 ) return;

	    OBJMetodo met = newClass.FindMetodo( listMethods.getItem(index) );
	    if( met == null ) return;

	    newClass.RemoveMetodo( met );
	    listMethods.delItem( index );
	}


	public boolean handleEvent(Event event)
	{
	    if(event.id == Event.WINDOW_DESTROY)
	    {
	        hide();
	        return true;
	    }
		if (event.target == btnAtribNew && event.id == Event.ACTION_EVENT) {
			btnAtribNew_Clicked(event);
		}
		if (event.target == btnMethodNew && event.id == Event.ACTION_EVENT) {
			btnMethodNew_Clicked(event);
		}

		if( event.target == this )
		{
		    if( event.id == DlgAttribute.EVENTO_OK )
		    {
		        switch( estado )
		        {
		            case 1: // NOVO_ATRIB:
		            {
            		    // Adiciona atributo na classe
            		    OBJAtributo atr = (OBJAtributo) event.arg;
            		    newClass.AddAtributo( atr );
            		    listAttrib.addItem( atr.GetNome() );
            		    break;
            		}

            		case 2: // EDIT_ATRIB;
            		{
            		    // Atualiza Lista
            		    OBJAtributo atr = (OBJAtributo) event.arg;
            		    int index = listAttrib.getSelectedIndex();
            		    listAttrib.replaceItem( atr.GetNome(), index );
            		    break;
            		}

            		case 3: // NOVO_METODO:
            		{
            		    // Adiciona metodo na classe
            		    OBJMetodo met = (OBJMetodo) event.arg;
            		    newClass.AddMetodo( met );
            		    listMethods.addItem( met.GetNome() );
            		    break;
            		}

            		case 4: // EDIT_Metodo;
            		{
            		    // Atualiza Lista
            		    OBJMetodo met = (OBJMetodo) event.arg;
            		    int index = listMethods.getSelectedIndex();
            		    listMethods.replaceItem( met.GetNome(), index );
            		    break;
            		}

            		default:
                }
		        estado = 0;
		    }
		    else
		    if( event.id == DlgAttribute.EVENTO_CANCEL )
		        estado = 0;
		}

		if (event.target == btnAtribEdit && event.id == Event.ACTION_EVENT) {
			btnAtribEdit_Clicked(event);
		}
		if (event.target == btnMethodEdit && event.id == Event.ACTION_EVENT) {
			btnMethodEdit_Clicked(event);
		}
		if (event.target == btnMethodRemove && event.id == Event.ACTION_EVENT) {
			btnMethodRemove_Clicked(event);
		}
		if (event.target == btnAtribRemove && event.id == Event.ACTION_EVENT) {
			btnAtribRemove_Clicked(event);
		}
		if (event.target == btnOK && event.id == Event.ACTION_EVENT) {
			btnOK_Clicked(event);
		}
		if (event.target == btnCancel && event.id == Event.ACTION_EVENT) {
			btnCancel_Clicked(event);
		}
		return super.handleEvent(event);
	}

    public OBJClasse GetClasse()
    {
        return p_classe;
    }

    public void SetClasse( OBJClasse classe )
    {
        p_classe = oldClass = classe;

        if( classe == null )
            return;

        newClass = classe.Clone();
        DataToView();
    }

    protected void DataToView()
    {
        textName.setText( newClass.GetNome() );
        textSter.setText( newClass.GetEsteriotipo() );
        textParam.setText( newClass.GetParametros() );

        checkAbstrata.setState( newClass.IsAbstrata() );

        Vector v;
        Enumeration e;
        OBJCaracteristica carac;

        // Atributos
        listAttrib.clear();
        v = newClass.GetAtributos();
        e = v.elements();
        while( e.hasMoreElements() )
        {
            carac = (OBJCaracteristica) e.nextElement();
            listAttrib.addItem( carac.GetNome() );
        }

        // Metodos
        listMethods.clear();
        v = newClass.GetMetodos();
        e = v.elements();
        while( e.hasMoreElements() )
        {
            carac = (OBJCaracteristica) e.nextElement();
            listMethods.addItem( carac.GetNome() );
        }

    }

    protected void ViewToData()
    {
        newClass.SetNome( textName.getText() );
        newClass.SetEsteriotipo( textSter.getText() );
        newClass.SetParametros( textParam.getText() );
        newClass.SetAbstrata( checkAbstrata.getState() );

        // PS: As listas sao atualizadas conforme atualizacao
    }


*/
}
