/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: COPSEServerApp
\******************************************************************************/


import java.io.*;
import java.util.*;



public class COPSEServerApp
{

    public static void main( String[] args )
    {
        new COPSEServerApp().run( args );
    }


    COPSEServer    pServer;

    public COPSEServerApp() {}

    private void run (String[] args)
    {
        System.out.println( "COPSEServerApp - Test" );

        if( args.length < 2 )
        {
            System.out.println( "Parameters:\n   <project_name> <port_number>" );
            return;
        }

        try {
            pServer = new COPSEServer( args[0], "localhost", new Integer(args[1]).intValue() );
            pServer.start();
        } catch( Exception e )
        {
            System.out.println( "Error on starting COPSEServer" );
            System.exit(0);
        }


        System.out.println("Server On");
        System.out.print(":");

        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

        String command;
        do {
            command = "";
            try {
                StringTokenizer st = new StringTokenizer(in.readLine());
                if( st.hasMoreTokens() )
                {
                    command = st.nextToken();

                    if( command.equals( "exit" ) )
                    {
                        pServer.Exit();
                    }
                    else
                        System.out.print(":");
                }
            } catch (IOException ioe )
            {
                System.out.println( "DEBUG: Error os String Tokenizer ...");
            }

        } while( !command.equals("exit") );

    }
}