/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe:  COPSEServerSession
\******************************************************************************/


import java.io.*;
import java.util.*;

import COPSE.*;
//import COPSE.SERVER.*;


public class COPSEServerSession
    extends COPSESession
{
    protected   COPSEServerConnectionHandler      pConnectionHandler;

    public COPSEServerSession( int userId )
    {
        super( userId );
        pConnectionHandler = null;
    }

    public COPSEServerConnectionHandler GetConnectionHandler()
    {
        return pConnectionHandler;
    }

    public void SetConnectionHandler( COPSEServerConnectionHandler handler )
    {
        try {
            if( pConnectionHandler != null )
                pConnectionHandler.Close();
        } catch (Exception e) {}

        pConnectionHandler = handler;
    }

    public void Close()
    {
        pConnectionHandler.Close();
        pConnectionHandler = null;
    }

    public void Notify( CEvent event )
    {
        try {
            pConnectionHandler.Send( event );
        } catch( IOException ioe ) {};
    }

    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "  COPSEServerSession: [uId: "+mUserId+"]" );
    }

    public COPSESession CloneAsCOPSESession()
    {
        return new COPSESession( GetUserId() );
    }

}
