/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: COPSEServerUsersManager
\******************************************************************************/


import java.io.*;
import java.util.*;


import COPSE.*;
import COPSE.CONTROL.*;
import FILE.*;
import AGENT.*;

//import PROCESS.MODEL.*;
//import PROCESS.*;


public class COPSEServerUsersManager
{
    protected   COPSEServerProjectManager       pProjectManager;

    protected   CFileController                 pUsersController;
    protected   CFile                           pUsers;


    public COPSEServerUsersManager( COPSEServerProjectManager manager )
        //throws Exception
    {
        pProjectManager = manager;

        String projectDir = pProjectManager.GetProjectDir();

        try
        {
            pUsers = CFile.Load( "users.copse", projectDir );
        } catch( Exception e )
        {
            pUsers = _CreateDefaultUsers( projectDir );
        }

        pUsersController = new CFileController( pUsers );
    }



    private CFile _CreateDefaultUsers( String projectDir )
    {
        CFile file = new CFile( "users.copse", projectDir );

        CMember member = new CMember();
        member.SetName("Project Administrator");
        member.SetLogin("admin");
        member.SetPassword("admin");
        file.AddElement( member );

        CTeam team = new CTeam();
        team.SetName( "Administration" );
        team.AddMember ( member );
        team.SetManager( member );
        file.AddElement( team );

        team = new CTeam();
        team.SetName( "Project Management" );
        team.SetManager( member );
        file.AddElement( team );

        team = new CTeam();
        team.SetName( "Development" );
        team.SetManager( member );
        file.AddElement( team );

        try {
            file.Save();
        } catch (IOException e) {};
        return file;
    }


    public CMember FindUserByLogin( String login )
    {
        Enumeration e = pUsers.GetElements();
        while( e.hasMoreElements() )
        {
            CElement elem = (CElement) e.nextElement();
            if( elem instanceof CMember )
            {
                CMember member = (CMember) elem;
                if( member.GetLogin().equals( login ) )
                    return member;
            }
        }
        return null;
    }

    public CFileController GetUsersController()     { return pUsersController; }

    public void Close()
    {
        // TODO: Verify any changes and save them
        //if( pUsersController.IsChanged() )
    }


}
