/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: ProcessManager
\******************************************************************************/


import java.io.*;
//import java.net.*;
import java.util.*;


import COPSE.*;
import FILE.*;
//import AGENT.*;

import PROCESS.MODEL.*;
import PROCESS.*;




public class ProcessManager
    extends Thread
{
    COPSEManager        pCOPSEManager;

    CProcess                pPrjProcess;
    //CProcessUsersSession    pPrjPrcUsers;

    ServerStreamConnector   pConnector;
    boolean             mExit;

    public ProcessManager( COPSEManager manager )
    {
        super();

        pCOPSEManager = manager;
        pPrjProcess = null;
        //pPrjPrcUsers = new CProcessUsersSession();
        pConnector = new ServerStreamConnector( pCOPSEManager.GetNewSocketPort() );
    }

    public void SetProjectProcess( CProcess process )
        throws IOException
    {
        pPrjProcess = process;
        ActivateProcessServer();
    }

/*

    public void AddUserToActivity( int actId, int userId )
    {
        synchronized( pPrjPrcUsers )
        {
            pPrjPrcUsers.AddEntry( actId, userId );
        }
    }

    public void RemoveUserFromActivity( int actId, int userId )
    {
        synchronized( pPrjPrcUsers )
        {
            pPrjPrcUsers.RemoveEntry( actId, userId );
        }
    }

    public CProcessUsersSession GetUsersInActivities()
    {
        return pPrjPrcUsers;
    }

*/
    public void run()
    {
        mExit = false;
        while( !mExit )
        {
            try {
                if( !pConnector.IsServerActive() )
                    suspend();
            } catch( SecurityException ie ) {};

            if( pConnector.IsServerActive() )
                try {
                    CEvent event = pConnector.Receive();
                    _ProcessEvent( event );
                }
                catch( java.io.IOException ioe ) {}
        }
    }

    private void _ProcessEvent( CEvent event )
    {
/*        switch( event.GetType() )
        {
            case CEvent.


        }
*/
    }

    public boolean  IsProcessServerActive()     { return pConnector != null; }

    //public
    protected void     ActivateProcessServer()
        throws IOException
    {
        if( pConnector.IsServerActive() )
            return;

        //try {
        Process process = Runtime.getRuntime().exec(
                "java ProcessServer " + pConnector.GetServerSocketPort() + " " );

        pConnector.SetServerProcess( process );

        // ??? Send pPrjProcess
        CEvent event = new CEvent( CEvent.EvServer_Init );
        event.AddArgument( pPrjProcess );
        pConnector.Send( event );

        event = pConnector.Receive();
        Boolean bool = (Boolean) event.GetArgumentAt(0);
        if( bool.booleanValue() )
        {
            this.resume();
        }
        else
        {
            pConnector.SetServerProcess( null );
            throw new IOException( "Error on starting ProcessServer up!" );
        }
        //}

    }

    public void Exit()
    {
        if( pConnector.IsServerActive() )
        {
            try {
                CEvent event = new CEvent( CEvent.EvServer_Exit );
                pConnector.Send( event );
            } catch ( IOException ioe )
            {
                mExit = true;
                resume();
                // ...

            }
        }
        else
        {
            mExit = true;
            resume();
            // ...
        }
    }

}