/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: ProcessUserServer
\******************************************************************************/


import java.io.*;
import java.util.*;


import COPSE.*;

//import FILE.*;
import PROCESS.MODEL.*;
import PROCESS.WORK.*;

//import AGENT.*;


public class ProcessUserServer
    extends CUserServer
{

    ProcessServer    pServer;

    public ProcessUserServer ( CServer server, int userId, int connId, CObjectStreamConnector conn )
    {
        super( server, userId, connId, conn );
        pServer = (ProcessServer) server;
    }

    protected void ProcessRequest( CEvent event )
    {
        System.err.println( "DEBUG: (ProcessUserServer.ProcessRequest) => event #" + event.GetType() );


        switch( event.GetType() )
        {

            case CEvent.EvProcessServer_Process_Load:
                // No arguments
                {
                    CEvent ev = new CEvent( CEvent.EvProcessServer_Process_Load );
                    ev.AddArgument( pServer.GetProcess() );
                    Send( ev );
                }
                break;

            case CEvent.EvProcessServer_ProcessUsersSession_Load:
                // No arguments
                {
                    CEvent ev = new CEvent( CEvent.EvProcessServer_ProcessUsersSession_Load );
                    ev.AddArgument( pServer.GetProcessUsersSession() );
                    Send( ev );
                }
                break;


            default:
                super.ProcessRequest( event );
        }
    }

}
