/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: CProcessManager
\******************************************************************************/


import java.io.*;
import java.util.*;

import COPSE.*;
import FILE.*;
import PROCESS.*;
import PROCESS.MODEL.*;

public class CProcessManager
    extends CServerManager
{
    COPSEServerProjectManager   pProjectManager;

/*
    CLocator                    pFileLocator;
    CFile                       pFile;

    int                         mServerSocketPort;
    CConnectionHandler          pConnection;
    CServerManagerEventHandler  pEventHandler;

    boolean                     mExit;
*/

    public static CProcessManager New (COPSEServerProjectManager projectManager)
        throws IOException
    {
        CProcessManager manager;
        CProcess process;

        try{
            process = (CProcess) CFile.Load( "process.copse", projectManager.GetProjectDir() );
        } catch (Exception e )
        {
            process = _CreateDefaultProcess( projectManager.GetProjectDir() );
        }

        manager = new CProcessManager( projectManager, process );

        return manager;
    }



    public CProcessManager( COPSEServerProjectManager manager, CProcess process )
        throws IOException
    {
        super( manager.GetNextServerSocketPort(), new CLocator(0,0,0), process );
        pProjectManager = manager;
    }



    private static CProcess _CreateDefaultProcess( String projectDir )
    {
        CProcess process = new CProcess( "process.copse", projectDir );

        CModelHeader header;
        process.AddElement( header = new CModelHeader() );
        process.SetModelHeader( header );
        header.SetName( "Process" );

        CSubModel   submodel;
        process.AddElement( submodel = new CSubModel() );

        header.SetSubModel( submodel );

        process.SetupActivities();

        try {
            process.Save();
        } catch (IOException e) {};
        return process;
    }

/*
    protected CServerManagerEventHandler   CreateEventHandler()
    {
        return new CProcessManagerEventHandler ( this );
    }
*/
    protected   String      GetServerName()     { return "ProcessServer"; }


}




/*
    public      CLocator    GetLocator()        { return pFileLocator; }
*/

/*
    protected void ActivateServer()
        throws IOException
    {
        String serverName = GetServerName();

        Process process = Runtime.getRuntime().exec(
                "java " + serverName + " " + mServerSocketPort );

        CProcessStreamConnector connector = CProcessStreamConnector.New( process );

        pEventHandler = CreateEventHandler();

        pConnection = new CConnectionHandler( connector, pEventHandler );
        pConnection.start();


        // Send Init Event
        CEvent event = new CEvent( CEvent.EvCOPSE_Server_Init );
        event.AddArgument( pFile );
        pConnection.Send( event );


/*
        // ??? Send pPrjProcess
        CEvent event = new CEvent( CEvent.EvServer_Init );
        event.AddArgument( pPrjProcess );
        pConnector.Send( event );

        event = pConnector.Receive();
        Boolean bool = (Boolean) event.GetArgumentAt(0);
        if( bool.booleanValue() )
        {
            this.resume();
        }
        else
        {
            pConnector.SetServerProcess( null );
            throw new IOException( "Error on starting ProcessServer up!" );
        }
        //}
    }
*/


/*
    public void Close()
    {
        if( pConnection != null )
        {
            try{
                CEvent event = new CEvent( CEvent.EvCOPSE_Server_Exit );
                pConnection.Send( event );
            } catch( IOException e )
            {
                pConnection.Close();
            }

            // pConnection.join(); // ???
        }
    }
*/
        /*
        if( pConnector.IsServerActive() )
        {
            try {
                CEvent event = new CEvent( CEvent.EvCOPSE_Server_Exit );
                pConnector.Send( event );
            } catch ( IOException ioe )
            {
                mExit = true;
                resume();
                // ...

            }
        }
        else
        {
            mExit = true;
            resume();
            // ...
        }
        */



