/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: CUsersManager
\******************************************************************************/


import java.io.*;
import java.util.*;


import COPSE.*;

import FILE.*;
import AGENT.*;

//import PROCESS.MODEL.*;
//import PROCESS.*;


public class CUsersManager
{
    protected   COPSEServerProjectManager         pProjectManager;

    protected   CFileController             pFileController;
    protected   CFile                       pUsers;


    public CUsersManager( COPSEServerProjectManager manager )
        //throws Exception
    {
        pProjectManager = manager;

        String projectDir = pProjectManager.GetProjectDir();

        try
        {
            pUsers = CFile.Load( "users.copse", projectDir );
        } catch( Exception e )
        {
            pUsers = _CreateDefaultUsers( projectDir );
        }

        pFileController = new CFileController( pUsers );
    }



    private CFile _CreateDefaultUsers( String projectDir )
    {
        CFile file = new CFile( "users.copse", projectDir );

        CMember member = new CMember();
        member.SetLogin("admin");
        member.SetPassword("admin");
        member.SetName("Project Administrator");

        file.AddElement( member );

        try {
            file.Save();
        } catch (IOException e) {};
        return file;
    }


    public CMember FindUserByLogin( String login )
    {
        Enumeration e = pUsers.GetElements();
        while( e.hasMoreElements() )
        {
            CElement elem = (CElement) e.nextElement();
            if( elem instanceof CMember )
            {
                CMember member = (CMember) elem;
                if( member.GetLogin().equals( login ) )
                    return member;
            }
        }
        return null;
    }

    public void Close()
    {
        // TODO: Verify any changes and save them
        //if( pFileController.IsChanged() )
    }


}
